################
#####
#####
## Simulate Competing Diallels.R
##
##  The following code runs and saves a large amount of simulations to ones
##    harddrive assuming that setups are in place
##  Purpose of this is to enable standardized comparison of multiple simulations
##   by trying data against fixed inputs. 
##  However, the runtime of this process can take quite a while for any given machine
##   File "RParrallelPack.R" helps out by allowing scripts using SimulateCompetingDiallels
##   to run parrallel on multi-core systems (lsf networks or individual machines)
##  Memory use has been seen to be expanded however, as the tables collected in these
##   analyses are many, so it could require several restarts to complete a number of simulations.
##  However, this simulation method should be able to pick up and add a new simulation to the end of
##   processes whenever a system is restarted.  
## source("c://Users//Alan 1215//Documents//My Dropbox//RDiallel//BayesDiallel//R//SimulateCompetingDiallels.R");

require(R.oo);

MyCurrentCount = NULL;  PiAPrior = c(10,10,20,20); start=1;
MyiiExampleModels=NULL;  AllExampleModels=NULL;
Rt1 = 0; Rt2 = 0;

AFDS = NULL;  AFDSL = NULL;  AFD = NULL;  BSAFD = NULL;

AFDOO = NULL;
TryOOVals = c(3,6,15);

KillVerboseChains = TRUE;

dfStart = .5;  mStart = .5;  SimDfTNoise = -1;
RSIMNAMESPACE <- environment()
.onLoad <- function(libname, pkgname) {
## load the module and store it in our namespace
  ##BAYESSPIKENAMESPACE <- environment()

  Verbose = 0; eval(parse(text=SetGText("Verbose", S=1)));
  if (exists("AFD", globalenv())) {
    eval(parse(text=GetG0Text("AFD", S=1)));
    try(rm("AFD", envir=globalenv()));
  }
  AFD = NULL;
  eval(parse(text=LockGText("BSAFD")));
  if (exists("BSAFD", globalenv())) {
    eval(parse(text=GetG0Text("BSAFD", S=1)));
    try(rm("BSAFD", envir=globalenv()));
  }  
  BSAFD = NULL;
  eval(parse(text=LockGText("BSAFD")));
  if (exists("AFDSL", globalenv())) {
    eval(parse(text=GetG0Text("AFDSL", S=1)));
    try(rm("AFDSL", envir=globalenv()));
  }  
  try(.DefaultModelsIn <-  c("Griff", "DiallelLarge", "DiallelTRUE",
  "Diallelhglm"));
  eval(parse(text=SetGText(".DefaultModelsIn", "globalenv()", S=1)));
  AFDSL = NULL
  eval(parse(text=LockGText("AFDSL")));
   if (exists("AFDS", globalenv())) {
    eval(parse(text=GetG0Text("AFDS", S=1)));
    try(rm("AFDS", envir=globalenv()));
  }  
  AFDS = NULL;
  eval(parse(text=LockGText("AFDS")));
   if (exists("AFDOO", globalenv())) {
    eval(parse(text=GetG0Text("AFDOO", S=1)));
    try(rm("AFDOO", envir=globalenv()));
  }    
  AFDOO = NULL;
  eval(parse(text=LockGText("AFDS")));
    TryO = NULL;
  try( TryO <- bindingIsActive("AFDS", RSIMNAMESPACE), silent = TRUE);
  if (!is.null(TryO) && (TryO == TRUE || TryO == FALSE)) {
   unlockBinding( "AFDS" , RSIMNAMESPACE )
  }
  assign( "AFDS", NULL , RSIMNAMESPACE )
  lockBinding( "AFDSL", RSIMNAMESPACE )
  TryO = NULL; 
  try( TryO <- bindingIsActive("AFDSL", RSIMNAMESPACE), silent = TRUE);
  if (!is.null(TryO) && (TryO == TRUE || TryO == FALSE)) {
   unlockBinding( "AFDSL" , RSIMNAMESPACE )
  }
  assign( "AFDSL", NULL , RSIMNAMESPACE )
  lockBinding( "AFD", RSIMNAMESPACE )
  try( TryO <- bindingIsActive("AFD", RSIMNAMESPACE), silent = TRUE);
  if (!is.null(TryO) && (TryO == TRUE || TryO == FALSE)) {
   unlockBinding( "AFD" , RSIMNAMESPACE )
  }
  assign( "AFD", NULL , RSIMNAMESPACE )
  lockBinding( "AFD", RSIMNAMESPACE )
  TryO = NULL;
  try( TryO <- bindingIsActive("BSAFD", RSIMNAMESPACE), silent = TRUE);
  if (!is.null(TryO) && (TryO == TRUE || TryO == FALSE)) {
   unlockBinding( "BSAFD" , RSIMNAMESPACE )
  }
  assign( "BSAFD", NULL , RSIMNAMESPACE )
  lockBinding( "BSAFD", RSIMNAMESPACE )
  MyiiExampleModels = NULL;
  eval(parse(text=LockGText("MyiiExampleModels")));
  AllExampleModels = NULL;
  eval(parse(text=LockGText("AllExampleModels")));

  LModel = 1;
  eval(parse(text=LockGText("LModel")));
  MyDIC = NULL;
  eval(parse(text=LockGText("MyDIC")));
  DICMin = -1;
  eval(parse(text=LockGText("DICMin")));
  
  Rt1 = 0; Rt2 =0;
  eval(parse(text=LockGText("Rt1")));
  eval(parse(text=LockGText("Rt2")));
  
  TryOOVals = c(3,6,15);
  eval(parse(text=SetGText("TryOOVals", S=1)))
  
  PredSimMeanNames = "";
  PredMeanNames = "";
  PredMeanLength = 0;
  g = 1;
  eval(parse(text=SetGText("g", "globalenv()", S=1)));
  eval(parse(text=LockGText("PredSimMeanNames",S=1)));
  eval(parse(text=LockGText("PredMeanNames",S=1)));
  eval(parse(text=LockGText("PredMeanLength",S=1)));
  
  KillVerboseChains = TRUE;
  eval(parse(text=SetGText("KillVerboseChains")));    
  ajModel = 0; MotherModel = 0; CrossModel = 0; SexModel = 0;
  BetaHybridLevel = 0;  BetaHybridTimesSex = 0;
  BetaInbredLevel = 0;  BetaInbredTimesSex = 0;
  IsRandom=FALSE; IsFixed = FALSE; numj = 0; NumReps = 0;
  IdentifierList = list(ajModel=ajModel, MotherModel=MotherModel, 
  CrossModel = CrossModel, SexModel = SexModel, 
  BetaInbredLevel = BetaInbredLevel, BetaInbredTimesSex = BetaInbredTimesSex,
  IsRandom=IsRandom, IsFixed = IsFixed, numj = numj, NumReps = NumReps)
  eval(parse(text=LockGText("IdentifierList")));
  
  dfStart = .5;  mStart = .5;
  eval(parse(text=SetGText("dfStart", S=1)))
  eval(parse(text=SetGText("mStart", S=1)))
  SimDfTNoise = -1;
  eval(parse(text=SetGText("SimDfTNoise", S=1)))
  if (exists("SetSaveHomes", environment())) {
    SetSaveHomes();
  }
}


setConstructorS3("ASim", 
##envir = globalenv(),
 function(Simname = "", Verbose = 0, dfTNoise = -1,...) {
  if (!exists("AllDir")) {
    ##SetSaveHomes();
    SetSaveHomes(); ### Creates a Save Homes directory important to computer path
    eval(parse(text=GetG0Text("MySimUName")));
    if (!exists("MySimUName") || (length(MySimUName) == 1 &&
      is.numeric(MySimUName) && MySimUName == 0)) {
      MySimUName = "AnonySim";
      eval(parse(text=LockGText("MySimUName")));  
    }
    AllDir <- paste(SAVEHOME, "//", MySimUName, sep="");
      dir.create(AllDir, showWarnings=TRUE);
  }
  if (!exists("dfTNoise") || is.null(dfTNoise)) {dfTNoise = -1}
  PreferMeanMedian = "MEAN";
  PreferSmpValMIPVal = "SmpVal";
  AllDir2 = "";
  if(Simname == "Griff") {
    AllDir2 = paste(AllDir, "//Griff", sep="");
      dir.create(AllDir2, showWarnings=TRUE);
    Type = "Griff"
  } else if (Simname == "GriffSat") {
    AllDir2 = paste(AllDir, "//GriffSat", sep="");
      dir.create(AllDir2, showWarnings=TRUE);
    Type = "GriffSat"
  } else if (Simname == "DiallelLarge") {
    AllDir2 = paste(AllDir, "//DiallelLarge", sep="");
      dir.create(AllDir2, showWarnings=TRUE);
    Type = "DiallelLarge"  
  } else if (Simname == "hglm" || Simname == "Diallelhglm" || Simname == "DiallelHglm") {
    AllDir2 = paste(AllDir, "//Diallelhglm", sep="");
    dir.create(AllDir2, showWarnings=TRUE);
    Type = "Diallelhglm";
  } else if (Simname == "DiallelDICMin") {
    AllDir2 = paste(AllDir, "//DiallelDICMin", sep="");
      dir.create(AllDir2, showWarnings=TRUE);
    Type = "DiallelDICMin"
  } else if (Simname == "DiallelTRUE") {
    AllDir2 = paste(AllDir, "//DiallelTRUE", sep="");
      dir.create(AllDir2, showWarnings=TRUE);
    Type = "DiallelTRUE";
  } else if (Simname == "DiallelSpike") {
    library(BayesSpike);
    AllDir2 = paste(AllDir, "//DiallelSpike", sep="");
      dir.create(AllDir2, showWarnings=TRUE);
    Type = "DiallelSpike"
    PreferMeanMedian = "MEDIAN";
    PreferSmpValMIPVal = "MIPVal";
  } else if (substr(Simname,1,nchar("DiallelLargeOutlier"))
    == "DiallelLargeOutlier") {
    AllDir2 = paste(AllDir, "//", Simname,sep="");
      dir.create(AllDir2, showWarnings=TRUE);
    Type = "DiallelLargeOutlier";
    PreferMeanMedian = "MEAN";
    PreferSmpValMIPVal = "SmpVal";
    if (dfTNoise == -1) {
      ABS = substr(Simname,nchar("DiallelLargeOutlier")+1,nchar(Simname));
      ABS = as.numeric(ABS);
      dfTNoise = ABS;
    }
  } else if (substr(Simname,1,nchar("DiallelSpikeOutlier"))
    == "DiallelSpikeOutlier") {
    library(BayesSpike);
    AllDir2 = paste(AllDir, "//", Simname, sep="");
      dir.create(AllDir2, showWarnings=TRUE);
    Type = "DiallelSpikeOutlier"
    PreferMeanMedian = "MEDIAN";
    PreferSmpValMIPVal = "MIPVal";
    if (dfTNoise == -1) {
      ABS = substr(Simname,nchar("DiallelSpikeOutlier")+1,nchar(Simname));
      ABS = as.numeric(ABS);
      dfTNoise = ABS;
    }
  } else if (Simname == "") {
    return(NULL);
  } else {
    return(NULL);
  }
  if (!exists("AllDir2") || (is.character(AllDir2) && AllDir2 == "")) {
    print(paste("Error create ASim, never created AllDir2, Simname was",
      Simname, sep="")); flush.console();
  }
  MyRet =  extend(Object(), "ASim", AllDir2=AllDir2, Type=Type,
    MyOA = NULL, MyOAMX = NULL, Verbose = Verbose,
    PreferMeanMedian = PreferMeanMedian,
    PreferSmpValMIPVal = PreferSmpValMIPVal, dfTNoise = dfTNoise);
  return(MyRet);
});

setConstructorS3("Simmers", 
##envir=globalenv(), 
function(ModelsIn = NULL, 
  Verbose = 0, OnlyNeedTablesList = NULL, ...) {
  if (is.null(ModelsIn)) {
    ModelsIn = .DefaultModelsIn;
  }
  SimL = list();
  for (ii in 1:length(ModelsIn)) {
    if (Verbose > 0) {
      print(paste("Simmers: Constructing Simmers for Model ", ModelsIn[ii], sep="")); flush.console();
    }
    SimL[[ii]] = BayesDiallel:::ASim(ModelsIn[ii]);
  }
  AR = extend(Object(), "Simmers", SimL=SimL, Verbose =Verbose, OnlyNeedTablesList = OnlyNeedTablesList)
  return(AR);
});






SetSaveHomes <- function() {

##print("BayesDiallel SetSaveHomes start trying to use Alan Directories!");
flush.console();
AT1 = FALSE;
MyT1 = "try(library(AlanDirectories));  AT1 <- TRUE";
try(eval(parse(text=MyT1)), silent=FALSE);
if (AT1 == FALSE) {
  #print("BayesDiallel, failed to load in Directory AlanDirectories");
  flush.console();
}
#print("BayesDiallel:: done loading AlanDirectories.");flush.console();
AT2 = FALSE;
MyT2 = "AlanDirectories:::SetSaveHomes();  AT2 <- TRUE";
try(eval(parse(text=MyT2)), silent=FALSE);
##print("BayesDiallel:: done running AlanDirectories:::SetSaveHomes()");flush.console();
if (AT2 == FALSE) {
  #print("BayesDiallel, failed to run AlanDirectories:::SetSaveHomes()");
  flush.console();
} else {
  #print("BayesDiallel, succesfully ran AlanDirectories:::SetSaveHomes()"); 
  flush.console();
  return(1);
}
ATT = FALSE;
MyT = "try(library(AlanDirectories), silent=FALSE);
  try(AlanDirectories:::SetSaveHomes(), silent=FALSE);
  ATT = TRUE";
try(eval(parse(text=MyT)), silent=FALSE);
if (ATT == TRUE) { 
  #print("BayesDiallel, went to second step and ran AlanDirectories"); flush.console();
  return(1); }

.DefaultModelsIn <- c("Griff", "GriffSat", "DiallelLarge",
  "DiallelDICMin", "DiallelTRUE", "DiallelSpike","Diallelhglm");


try(eval(parse(text=GetG0Text("BSSaveDir",S=1))),silent=TRUE);
eval(parse(text=GetG0Text("SAVEHOME", S=1)));
eval(parse(text=GetG0Text("FILEHOME", S=1)));
eval(parse(text=GetG0Text("DropHome", S=1)));
eval(parse(text=GetG0Text("BSNumChains", S=1)));
eval(parse(text=GetG0Text("BSLengthChains", S=1)));

  BSSaveDir = "";
  SAVEHOME = ""; OTHERSAVEHOME=""; FILEHOME = ""; DropHome = ""
  BSLengthChains <- 2000;  BSNumChains <- 5;

eval(parse(text=SetGText("BSSaveDir", S=1)))
eval(parse(text=SetGText("SAVEHOME", S=1)))
eval(parse(text=SetGText("OTHERSAVEHOME", S=1)))
eval(parse(text=SetGText("FILEHOME", S=1)))
eval(parse(text=SetGText("DropHome", S=1)))
eval(parse(text=SetGText("BSLengthChains", S=1)))
eval(parse(text=SetGText("BSNumChains", S=1)))
}




setMethodS3("CheckToTarget", "ASim", function(this, Verbose = 0,...) {
  if (!is.null(Verbose) && Verbose > 0) {
    this$Verbose = Verbose;
  } else {
    if (!is.null(this$Verbose)) {
      Verbose = this$Verbose;
    }
  }
  MyTT = CountTables(this, Verbose=Verbose);
  MyTarget = this$MyOA$TargetLength;
  MyTMin = min(MyTT$MyOne);
  MyD = MyTarget - MyTMin;
  if (!is.null(this$MyOAMX)) {
    MyTarget2 = this$MyOAMX$TargetLength;
    MyD2 = MyTarget2 - min(MyTT$MyTwo);
    MyD = max(MyD2, MyD);
  }
  return(MyD);
});
setMethodS3("CheckToTarget", "Simmers", function(this, Verbose=0,...) {
   if (!is.null(Verbose) && Verbose > 0) {
    this$Verbose = Verbose;
  } else {
    if (!is.null(this$Verbose)) {
      Verbose = this$Verbose;
    }
  }
  MyL = rep(0, length(this$SimL));
  for (ii in 1:length(MyL)) {
    MyL[ii] = CheckToTarget(this$SimL[[ii]]);
  }
  return(max(MyL));
});
setMethodS3("CountTables", "ASim", 
##envir=.GlobalEnv, 
function(this, Verbose = 0, ...) {
  if (!is.null(Verbose) && Verbose > 0) {
    this$Verbose = Verbose;
  } else {
    if (!is.null(this$Verbose)) {
      Verbose = this$Verbose;
    }
  }
  MyOne = NULL;  MyTwo = NULL;
  if (!is.null(this$MyOA)) {
    MyOne = BayesDiallel:::LengthSimAnalyses(this$MyOA, Verbose = Verbose-1);  
  }
  if (!is.null(this$MyOAMX)) {
    MyTwo = BayesDiallel:::LengthSimAnalyses(this$MyOA, Verbose = Verbose-1);
  }
  return(list(MyOne = MyOne, MyTwo = MyTwo));
});

###############################################################################
## CountTables methods attempt to count and tally all fo the tables and names
##   in the simulators, counting essentially the ReadTables to see how much data
##   is collectively saved in the tables;
setMethodS3("CountTables", "Simmers", 
##envir=.GlobalEnv,
  function(this,Verbose = 0, ...) {
  MyOneList = list();
  MyTwoList = list();
  nMyOneList = rep("", length(this$SimL));
  nMyTwoList = rep("", length(this$SimL));
  LMTL = 0;
  LMOL = 0;
  LnMTL = 0;
  LnMOL = 1;

  for (ii in 1:length(this$SimL)) {
    if (Verbose > 1) {
      print(paste("CountTables:  Checking out Tabi = ", ii, " with ",
        this$SimL[[ii]]$Type, sep="")); flush.console();
    }
    MyG = CountTables(this$SimL[[ii]], Verbbose = Verbose -1);
    if (is.null(this$SimL[[ii]]$Type)) {
      this$SimL[[ii]]$Type = "NoType";
      print(paste("CountTables, uh oh, SimL ii = ", ii, ", has no type!", sep=""));
      flush.console();
    }
    if (length(MyG) == 2) {
      MyOneList[[ii]] = MyG[[1]]; nMyOneList[ii] = this$SimL[[ii]]$Type;
      LMOL = LMOL +1;  LnMOL = LnMOL+1;
      if (is.null(MyG[[2]])) {
        MyTwoList[[ii]] = -1;  nMyTwoList[ii] = this$SimL[[ii]]$Type;
      } else {
        MyTwoList[[ii]] = MyG[[2]]; nMyTwoList[ii] = this$SimL[[ii]]$Type;
      }
    } else if (length(MyG) == 1) {
      MyOneList[[ii]] = MyG[[1]]; nMyOneList[ii] = this$SimL[[ii]]$Type;
      MyTwoList[[ii]] = 0;  nMyTwoList[ii] = this$SimL[[ii]]$Type;
    }
    if (length(MyTwoList) != length(nMyTwoList)) {
      print(paste("CountTables Error, on ii = ", ii, " we have ",
        "length(MyTwoList) = ", length(MyTwoList), "  but ",
        "length(nMyTwoList) = ", length(nMyTwoList), sep=""));
      flush.console();
    }
  }
  if (length(MyOneList) != length(nMyOneList)) {
    print(paste("CountTables Error at end ii = ", ii, " we have ",
      "length(MyOneList) = ", length(MyOneList), " but ",
      "length(MyOneListn) = ", length(nMyOneList), sep="")); flush.console();  
  }
  if (length(MyTwoList) != length(nMyTwoList)) {
    print(paste("CountTables Error at end ii = ", ii, " we have ",
      "length(MyTwoList) = ", length(MyTwoList), " but ",
      "length(nMyTwoList) = ", length(nMyTwoList), sep="")); flush.console();
  }
  try(names(MyOneList) <- nMyOneList);
  if (length(MyTwoList) >= 1) {
    try(names(MyTwoList) <- nMyTwoList);
  }
  return(list(MyOneList=MyOneList, MyTwoList=MyTwoList));
});


setMethodS3("ReadASmallSimmer", "Simmers", function(this, MaxReadLength = 50, Verbose = 0,
  OnlyNeedTablesList = NULL, KillLockFiles = FALSE,...) {
  if (!exists("OnlyNeedTablesList") || is.null(OnlyNeedTablesList)) {
    OnlyNeedTablesList = this$OnlyNeedTablesList;
  }
  if (Verbose > 1) {
    print(paste("ReadMinorLength, Simmer, we're starting for read = ",
      MaxReadLength, sep="")); flush.console();
  }
  for (ii in 1:length(this$SimL)) {
    if (Verbose >= 0) {
      print(paste("ReadMinorLength:  for Simmer ii = ", ii, " Type = ",
        this$SimL[[ii]]$Type, " Need ", MaxReadLength,
        " from ", length(OnlyNeedTablesList), " tables. ",
        sep="")); flush.console();
    }
    this$SimL[[ii]]$MyOA$ReadMinorLength(MaxReadLength, Verbose = Verbose-1,
      OnlyNeedTablesList = OnlyNeedTablesList,  KillLockFiles = KillLockFiles);
    if (!is.null(this$SimL[[ii]]$MyOAMX)) {
      if (Verbose > 1) {
        print(paste("ReadMinorLength:  for Simmer ii = ", ii, " on the OAX", sep="")); flush.console();
      }
      this$SimL[[ii]]$MyOAMX$ReadMinorLength(MaxReadLength, Verbose = Verbose-2,
        OnlyNeedTablesList = OnlyNeedTablesList, KillLockFiles = KillLockFiles);  
    }
    if (Verbose >= 0) {
      if (is.null(this$SimL[[ii]]$MyOA$MeanVals$ReadTable) ||
        is.null(dim(this$SimL[[ii]]$MyOA$MeanVals$ReadTable)) ||
         dim(this$SimL[[ii]]$MyOA$MeanVals$ReadTable) != 2) {
        print(paste("Sorry, for ii = ", ii, ", Type = ",
          this$SimL[[ii]]$Type, " we don't have a read table yet", sep=""));
        flush.console();
      } else {
        MyPT = "";
        try(MyPT <- paste("ReadMinorLength, read ", length(OnlyNeedTablesList),
        " tables, Mean is length: ",
          length(this$SimL[[ii]]$MyOA$MeanVals$ReadTable[,1]), sep="" ));
          try(print(MyPT));
      }
      flush.console();
    }
  }  
  return();      
});

setMethodS3("RunSim", "ASim", 
##envir=.GlobalEnv, 
function(this, Verbose = 0, JustStart = FALSE, ...) {
  if (Verbose > 0) {
    this$Verbose = Verbose;
  }
  if (!exists("JustStart")) { JustStart = TRUE; }
  if (JustStart == TRUE) { return(); }
  eval(parse(text=GetG0Text("TrueParametersList", S=1)));
  eval(parse(text=GetG0Text("APredMean", S=1)));
  eval(parse(text=GetG0Text("HitSimPreds", S=1)));
  eval(parse(text=GetGText("AFD", S=1)));
  eval(parse(text=GetGText("AllXP", S=1)));
  eval(parse(text=GetG0Text("StartOnSimID", S=1)));  

  eval(parse(text=GetG0Text("UpdateVerbose", S=1)));
    
  if (!is.null(this$Verbose) && this$Verbose > 0) {
     print(paste("RunSim: running for Type = ", this$Type, sep="")); flush.console();
  }
  if (!exists("XP")) {
    if (!exists("XP", globalenv())) {
      XP = AFD$X;
      eval(parse(text=SetGText("XP", S=1)));
    }
  }
  if (this$Type == "DiallelSpike"  || this$Type == "DiallelSpikeOutlier") {
     XP = AFD$X;
    eval(parse(text=GetGText("PiAPrior")));
    eval(parse(text=GetGText("BSSaveDir")));
    eval(parse(text=GetGText("BSLengthChains")));
    eval(parse(text=GetGText("BSNumChains")));   
    eval(parse(text=GetGText("AFDS")));
    
    eval(parse(text=GetG0Text("PriorProbAllTau")));
    eval(parse(text=GetG0Text("PriorProbAllFixed")));
    if (!is.null(PriorProbAllTau) && PriorProbAllTau == 0) {
      PriorProbAllTau = .5;  
    }
    if (!is.null(PriorProbAllFixed) && PriorProbAllFixed  == 0) {
      PriorProbAllFixed = .5;
    }
    if (!exists("Verbose")) { Verbose = 0; }
    
    Sigma = AFDS$ADiallelOb$Sigma;
    eval(parse(text=LockGText("AFDS")));
    if (!is.null(this$dfTNoise)) {dfTNoise = this$dfTNoise; }
    if (dfTNoise > 0) {
     print(paste("DiallelSpike:  We're going to go with dfTNoise = ", dfTNoise, sep=""))
     print(paste("DiallelSpike:: Actually, we are going to do this shirt.", sep=""));
     ##dfTNoise = -1;
     flush.console();
    }
    namesX = colnames(AFD$X);
    FixedVariableIds = (1:length(namesX))[namesX %in% AFD$.AllFixedVariables];
    StList = c();  EndList = c();   namesList = c();
    for (ii in 1:length(AFD$.AllRandomVariables)) {
      MyVar = (1:length(namesX))[ substr(namesX,1,nchar(AFD$.AllRandomVariables[ii])) ==
      AFD$.AllRandomVariables[ii]];
      if (length(MyVar) > 0) {
        StList = c(StList, min(MyVar)); EndList = c(EndList, max(MyVar));
        namesList = c(namesList, AFD$.AllRandomVariables[ii]);
      }
    }
    names(EndList) = namesList;
    tauEndList = EndList;
    if (exists("PriorProbAllFixed") && PriorProbAllFixed > 0) {
      PriorProbFixed = rep(PriorProbAllFixed, length(FixedVariableIds));
    } else {
      PriorProbFixed = NULL;
    }
    if (exists("PriorProbAllTau") && PriorProbAllTau > 0) {
      PriorProbTau = rep(PriorProbAllTau, length(EndList));
    } else {
      PriorProbTau = NULL;
    }
    ##dfTNoise = -1;
    BSAFD = BayesSpike:::BayesSpikeFromAutoDiallel(AFD,
      LengthChains=BSLengthChains, NumChains = BSNumChains,
      Verbose = 0, DoRecord=c(1,1,1,0,0,1,1), 
      SigmaPrior = c(1,Sigma), PiAPrior = PiAPrior,
      tauPriordf = 2, tauPriorMean = 2, Run=FALSE, 
      SaveDir=BSSaveDir, tauFixed = 30, dfTNoise = dfTNoise,
      PriorProbTau = PriorProbTau, PriorProbFixed=PriorProbFixed);
    if (Verbose > 0) {
      print("About to assign BSAFD To Global Environment"); flush.console();
    }
    eval(parse(text=SetGText("BSAFD", "globalenv()")));
    BSAFD$Verbose = 1;
    BayesSpike:::RenameBSAFDCoda(BSAFD, TrueParametersList);
    if (Verbose > 0) {
      print("About to run BSAFD Regression"); flush.console();
    }
    bst1 = proc.time();
      BayesSpike:::RunRegression(BSAFD); 
    bst2 = proc.time();
    RGCodaList = (1:length(colnames(BSAFD$CodaList[[1]])))[
      substr(colnames(BSAFD$CodaList[[1]]),1,nchar("Prob")) != "Prob"]
    RTDCodaList = (1:length(colnames(BSAFD$CodaList[[1]])))[
      substr(colnames(BSAFD$CodaList[[1]]),1,nchar("Prob")) == "Prob"]
    CodaList  = list();  PCodaList = list();
    for (jj in 1:length(BSAFD$CodaList)) {
      CodaList[[jj]] = as.mcmc(BSAFD$CodaList[[jj]][,RGCodaList]);
      colnames(CodaList[[jj]]) = colnames(BSAFD$CodaList[[jj]])[RGCodaList]
      PCodaList[[jj]] = as.mcmc(BSAFD$CodaList[[jj]][,RTDCodaList]);
      colnames(PCodaList[[jj]]) = colnames(BSAFD$CodaList[[jj]])[RTDCodaList];
      PCodaList[[jj]] = as.mcmc(PCodaList[[jj]]);
      CodaList[[jj]] = as.mcmc(CodaList[[jj]]);
    }
    PTry = NULL;
    MyText = ("PCodaList <- as.mcmc(PCodaList); PTry <- 1;");
    try(eval(parse(text=MyText)));
    if (is.null(PTry)) {
       print(" Note, difficulty transitioning PCodalist to mcmc list!"); flush.console();
       MyText = "PCodaList <- as.mcmc.list(PCodaList); PTry <- 1;"
       try(eval(parse(text=MyText)));
    }
    if (length(BSAFD$PiAPrior) == 4) {
      PriorProb = c( BSAFD$PiAPrior[1] / sum(BSAFD$PiAPrior[1:2]),
        BSAFD$PiAPrior[3] / sum(BSAFD$PiAPrior[3:4]));
    } else if (length(BSAFD$PiAPrior) == 2) {
      PriorProb = c( BSAFD$PiAPrior[1] / sum(BSAFD$PiAPrior[1:2]));
    }  else  {PriorProb = NULL;}
    CodaList = as.mcmc(CodaList);  ##PCodaList = as.mcmc(PCodaList);
    end = length(CodaList[[1]][,1]);
    if (is.null(BSAFD$AFD)) {
      print("Well, oopsy, RunSim Simulating BayesSpike BSAFD in SimComplete Diallel, no AFD!");
      flush.console();
      eval(parse(text=GetG0Text("AFD")))
      BSAFD$AFD = AFD;
    }
    if (is.null(BSAFD$AFD$AllDiallelObs) || length(BSAFD$AFD$AllDiallelObs) <= 0) {
      print("Well, oopsy, RunSim Simulating BayesSpike BSAFD in SimComplete Diallel, no AFD$AllDiallelObs!");
      flush.console();
       SetupAnalysisMethods(
           AFD, BSAFD$AFD$ModelsList, numChains = length(AFD$AllDiallelObs$CodaChains), 
           lengthChains = NROW(AFD$AllDiallelObs$CodaChains[[1]]), 
           Sigma = AFD$AllDiallelObs[[1]]$Sigma,dfTNoise=dfTNoise, WeightsKeepFlag = FALSE, 
           Verbose = 0, Wanted=NULL, Extractor=NULL);
    }
    if (!is.null(BSAFD$AFD$AllDiallelObs[[1]]$DpBeta)) {
      MXBSAFDList = NULL;
      try(MXBSAFDList <- MXChain(CreateMatrixMX(BSAFD$AFD$AllDiallelObs[[1]]), CodaList));
      if (is.null(MXBSAFDList)) {
        print("Tried to create MXBSAFDList old way but failed ! "); flush.console();
      }
    } else {
      print("Note: BSAFD had to create new copy of AFD to try MXBS "); flush.console();
      NewAFD = Copy(AFD);
      eval(parse(text=GetG0Text("AllExampleModels", S=1)));
      SetupAnalysisMethods(NewAFD, AllExampleModels[1:2,], Sigma = 1,
       numChains = 3, lengthChains = 2000, dfTNoise = dfTNoise);
      NewAFD$AllDiallelObs[[1]]$CodaChains = CodaList;
      MXBSAFDList <- NULL;
      try(MXBSAFDList <- MXChain(CreateMatrixMX(NewAFD$AllDiallelObs[[1]]), CodaList));
      if (is.null(MXBSAFDList)) {
        print("Tried to create MXBSAFDList second way but failed ! "); flush.console();
      } else {
        print("Succeeded in creating MXBSAFDList"); flush.console();
      }
      finalize(NewAFD);
      try(rm("NewAFD"));
    }
    BSAFD$AFD$AllDiallelObs[[1]]$CodaChains = CodaList;
    BSAFD$AFD$AllDiallelObs[[1]]$PCodaChains = PCodaList;
    if (Verbose > -2) {
      print("BayesSpike: Write to Spike MyOA"); flush.console();
    }
    if (is.null(CodaList) || is.null(dim(CodaList[[1]])) ||
      length(dim(CodaList[[1]])) <= 1) {
      print("ASim: BayesSpike: Expect Error: We've got a NULL CodaList");
      flush.console();
    }
    BayesDiallel:::UpdateTables(this$MyOA, OutCoda=CodaList,
      TrueParam= TrueParametersList, Times=bst2-bst1, verbose = this$Verbose,
      DICFeed =c(0,0,0,0), GX = AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2 = AllXP, start=start,
      AddMIPVals = PCodaList, AModelObject = BSAFD$AFD$AllDiallelObs[[1]],
      ADataObject = BSAFD$AFD, RealX = AFD$X, RealY = BSAFD$Y, PriorProb = PriorProb,
      end = end, StartOnSimID = StartOnSimID);   
    if (Verbose > 0) {
      print("BayesSpike: Write to Spike MyOA"); flush.console();  
    }
    BSAFD$AFD$AllDiallelObs[[1]]$CodaChains = MXBSAFDList;
    BSAFD$AFD$AllDiallelObs[[1]]$PCodaChains = PCodaList;
    
    if (is.null(MXBSAFDList) ||
      is.null(dim(MXBSAFDList[[1]])) ||
      length(dim(MXBSAFDList[[1]])) <= 1) {
      print("ASim: BAYESSpike, expect error: we've got a NULL MXBSAFDList");
    }
    BayesDiallel:::UpdateTables(this$MyOAMX, OutCoda=MXBSAFDList,
      TrueParam= TrueParametersList, Times=bst2-bst1, verbose = this$Verbose,
      DICFeed =c(0,0,0,0), GX = AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2 = AllXP, start=start,
      AddMIPVals = PCodaList, AModelObject= BSAFD$AFD$AllDiallelObs[[1]],
      ADataObject=BSAFD$AFD, RealX = AFD$X, RealY = BSAFD$Y, PriorProb = PriorProb,
      end = end, StartOnSimID = StartOnSimID);  
    eval(parse(text=LockGText("PiAPrior")));
    eval(parse(text=LockGText("BSSaveDir")));
    eval(parse(text=LockGText("BSLengthChains")));
    eval(parse(text=LockGText("BSNumChains")));
    if (Verbose > 0) {
      print(paste("About to execute BSAFD, deleteme!", sep="")); flush.console();
    }
    BSAFD$DeleteMe(); 
    if (Verbose > 0) {
      print("about to Assign BSAFD as NULL back to global environment"); flush.console();
    }
    try(assign("BSAFD", NULL, globalenv() ));
    try(rm("BSAFD"));
    if (Verbose > 0) {
      print("BayesSpike: Write to Spike gc()"); flush.console();  
    }
    gc();
  } else if (this$Type == "DiallelTRUE") {  
    eval(parse(text=GetGText("MyiiExampleModels")));
    if (is.null(AFD)) {
      print("DiallelTrue:  AFD is null"); flush.console();
    }
    if (is.null(MyiiExampleModels) || length(MyiiExampleModels) == 0) {
      print("Well, MyiiExample Models is null  FMe!"); flush.console();
      MyiiExampleModels = FindExampleModels();
      eval(parse(text=LockGText("MyiiExampleModels")));
    } else if (MyiiExampleModels < 0 || MyiiExampleModels > length(AFD$AllDiallelObs)) {
      print(paste("Error: RunSim, we get MyiiExampleModels = ",
        MyiiExampleModels, " but length AFD$AllDiallelObs == ",
        length(AFD$AllDiallelObs), sep="")); flush.console();
    }
    t1 = proc.time();
    SetupChains(AFD$AllDiallelObs[[MyiiExampleModels]], 5, 4000)   
    eval(parse(text=GetGText("KillVerboseChains")));
    if (KillVerboseChains == TRUE) {
      RunChainsCC(AFD$AllDiallelObs[[MyiiExampleModels]], 
        AFD = AFD, ChainIter=-1, Verbose = -4); 
    } else {
      RunChainsCC(AFD$AllDiallelObs[[MyiiExampleModels]], 
        AFD = AFD, ChainIter=-1);     
    }  
    t2 = proc.time();    
    MXTRUE = BayesDiallel:::MXChain(CreateMatrixMX(AFD$AllDiallelObs[[MyiiExampleModels]]), 
      AFD$AllDiallelObs[[MyiiExampleModels]]$CodaChains)  
    eval(parse(text=GetG0Text("MyDIC")));
     XP = AFD$X;
    if (is.null(MyDIC) || length(MyDIC) == 1) {
      DICFeed = c(0,0,0,0);
    } else {
      DICFeed = MyDIC[MyiiExampleModels, 7:10]
    }
    end = length(AFD$AllDiallelObs[[MyiiExampleModels]]$CodaChains[[1]][,1])
    eval(parse(text=LockGText("MyDIC")));
    MXTrue = MXChain(CreateMatrixMX(AFD$AllDiallelObs[[MyiiExampleModels]]), 
      AFD$AllDiallelObs[[MyiiExampleModels]]$CodaChains)
    this$MyOA$UpdateTables(OutCoda=AFD$AllDiallelObs[[MyiiExampleModels]]$CodaChains,
      TrueParam= TrueParametersList, Times=t2-t1, verbose = UpdateVerbose,
      DICFeed = DICFeed, GX = AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2 = AllXP, start=start,
      AModelObject=AFD$AllDiallelObs[[MyiiExampleModels]],
      ADataObject=AFD, RealX = AFD$X, RealY = AFD$Y, end = end,
      StartOnSimID = StartOnSimID);  
    this$MyOAMX$UpdateTables(OutCoda=MXTrue,
      TrueParam= TrueParametersList, Times=t2-t1, verbose = UpdateVerbose,
      DICFeed = DICFeed, GX = AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2 = AllXP, start=start,
      AModelObject=AFD$AllDiallelObs[[MyiiExampleModels]],
      ADataObject=AFD, RealX = AFD$X, RealY = AFD$Y, end = end,
      StartOnSimID = StartOnSimID);  
    eval(parse(text=LockGText("MyiiExampleModels")));
  } else if (this$Type == "DiallelDICMin") {
     XP = AFD$X;
    eval(parse(text=GetRSIText("Rt1")));  eval(parse(text=GetRSIText("Rt2")));
    eval(parse(text=GetG0Text("MyDIC")));
    eval(parse(text=GetG0Text("DICMin")));
    t1 = proc.time();
    BayesDiallel:::SetupChains(AFD$AllDiallelObs[[DICMin]], 5, 4000)
    eval(parse(text=GetGText("KillVerboseChains")));
    if (KillVerboseChains == TRUE) {
      BayesDiallel:::RunChainsCC(AFD$AllDiallelObs[[DICMin]], AFD = AFD, ChainIter=-1, Verbose = -4);  
    } else {
      BayesDiallel:::RunChainsCC(AFD$AllDiallelObs[[DICMin]], AFD = AFD, ChainIter=-1);  
    }
    t2 = proc.time();
    if (is.null(MyDIC) || length(MyDIC) == 1) {
      DICFeed = c(0,0,0,0);
    } else {
      DICFeed = MyDIC[DICMin, 7:10]
    }
    end = length(AFD$AllDiallelObs[[DICMin]]$CodaChains[[1]][,1])
    eval(parse(text=LockGText("MyDIC")));
    MXDICMin = MXChain(CreateMatrixMX(AFD$AllDiallelObs[[DICMin]]), 
      AFD$AllDiallelObs[[DICMin]]$CodaChains)
    this$MyOA$UpdateTables(OutCoda=AFD$AllDiallelObs[[DICMin]]$CodaChains,
      TrueParam= TrueParametersList, Times=Rt2-Rt1+t2-t1, verbose = UpdateVerbose,
      DICFeed = DICFeed, GX=AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2 = AllXP, start=start,
      AModelObject=AFD$AllDiallelObs[[DICMin]],
      ADataObject=AFD, RealX = AFD$X, RealY = AFD$Y, end = end,
      StartOnSimID = StartOnSimID); 
    this$MyOAMX$UpdateTables(OutCoda=MXDICMin,
      TrueParam= TrueParametersList, Times=Rt2-Rt1+t2-t1, verbose = UpdateVerbose,
      DICFeed = DICFeed, GX=AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2 = AllXP, start=start,
      AModelObject=AFD$AllDiallelObs[[DICMin]],
      ADataObject=AFD, RealX = AFD$X, RealY = AFD$Y, end,
      StartOnSimID = StartOnSimID); 
    eval(parse(text=LockGText("DICMin")));       
    eval(parse(text=LockGText("Rt1")));  
    eval(parse(text=LockGText("Rt2")));    
  } else if (this$Type == "DiallelLarge") {
     XP = AFD$X;
    eval(parse(text=GetGText("LModel")));
    t1 = proc.time();
    SetupChains(AFD$AllDiallelObs[[LModel]], 5, 4000)  
    if (is.null(AFD$AllDiallelObs) || length(AFD$AllDiallelObs) < LModel) {
      print("Diallel Large big issues, AllDiallelObs has nothing after Setup Chains"); flush.console();
      eval(parse(text=SetGText("AFD")));
      tryCatch("This Supposes big error before UpdateTables");
    }
    eval(parse(text=GetGText("KillVerboseChains")));
    if (KillVerboseChains == TRUE) {
      RunChainsCC(AFD$AllDiallelObs[[LModel]], AFD = AFD, ChainIter=-1, Verbose = -4);
    }  else {
      RunChainsCC(AFD$AllDiallelObs[[LModel]], AFD = AFD, ChainIter=-1);
    }
   
    t2 = proc.time();  
    if (is.null(AFD$AllDiallelObs) || length(AFD$AllDiallelObs) < LModel) {
      print("Diallel Large big issues, AllDiallelObs has nothing after Run Chains"); flush.console();
      eval(parse(text=SetGText("AFD")));
      tryCatch("This Supposes big error before UpdateTables");
    }
    eval(parse(text=GetG0Text("MyDIC")));
    if (is.null(MyDIC) || length(MyDIC) == 1) {
      DICFeed = c(0,0,0,0);
    } else {
      DICFeed = MyDIC[LModel, 7:10]
    }
    end = length(AFD$AllDiallelObs[[LModel]]$CodaChains[[1]][,1]);
    eval(parse(text=LockGText("MyDIC")));
    if (Verbose > 0) {
      print("We're Making MXLModel!"); flush.console();
    }
    MXLModel <- NULL;
    if (is.null(AFD$AllDiallelObs) || length(AFD$AllDiallelObs) < LModel) {
      print("Diallel Large big issues, AllDiallelObs before goint to make MXLModel"); flush.console();
      eval(parse(text=SetGText("AFD")));
      tryCatch("This Supposes big error before UpdateTables");
    }    
    try(MXLModel <- MXChain(CreateMatrixMX(AFD$AllDiallelObs[[LModel]]), 
      AFD$AllDiallelObs[[LModel]]$CodaChains));
      
    if (is.null(MXLModel)) {
      print("MXLModel: Tried to make it but we failed DiallelLarge is broke");
      flush.console();
    }
    end = length(AFD$AllDiallelObs[[LModel]]$CodaChains[[1]][,1]);
        
    if (is.null(AFD$AllDiallelObs) || length(AFD$AllDiallelObs) < LModel) {
      print("Diallel Large big issues, AllDiallelObs has nothing after end created"); flush.console();
      tryCatch("This Supposes big error before UpdateTables");
    }
    eval(parse(text=GetG0Text("StartOnSimID", S=1)));
    this$MyOA$UpdateTables(OutCoda=AFD$AllDiallelObs[[LModel]]$CodaChains,
      TrueParam= TrueParametersList, Times=t2-t1, verbose = UpdateVerbose,
      DICFeed = DICFeed, GX=AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2 = AllXP, start=start,
      AModelObject=AFD$AllDiallelObs[[LModel]],
      ADataObject=AFD, RealX = AFD$X, RealY = AFD$Y, end = end, PCodaList=NULL,
      StartOnSimID = StartOnSimID);
    if (is.null(AFD$AllDiallelObs) || length(AFD$AllDiallelObs) < LModel) {
      print("Diallel Large big issues, AllDiallelObs has nothing after MyOA$UpdateTables"); flush.console();
      eval(parse(text=SetGText("AFD")));
      tryCatch("This Supposes big error before UpdateTables");
    }     
    UpdateTables(this$MyOAMX, OutCoda=MXLModel,
      TrueParam= TrueParametersList, Times=t2-t1, verbose = UpdateVerbose,
      DICFeed = DICFeed, GX=AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2 = AllXP, start=start,
      AModelObject=AFD$AllDiallelObs[[LModel]],
      ADataObject=AFD, RealX = AFD$X, RealY = AFD$Y, end=end, PCodaList = NULL,
      StartOnSimID = StartOnSimID);
    if (is.null(AFD$AllDiallelObs) || length(AFD$AllDiallelObs) < LModel) {
      print("Diallel Large big issues, AllDiallelObs has nothing after MyOAMX$UpdateTables"); flush.console();
      eval(parse(text=SetGText("AFD")));
      tryCatch("This Supposes big error before UpdateTables");
    }     
    eval(parse(text=LockGText("LModel")));
    if (!exists("Verbose") || is.null(Verbose)) {
      eval(parse(text=GetG0Text("Verbose")));
    }
    if (Verbose > 1) {
      print("About to copy AFD Large from AFD after running large diallel"); flush.console();
    }
    if (is.null(AFD$AllDiallelObs) || length(AFD$AllDiallelObs) <= 0) {
      print("RunASimulaiton, Error, AFD has no AllDiallelObs now!"); flush.console();
      tryCatch("Likely an error in the algorithm C code!");
    }
    AFDLarge = Copy(AFD);
    eval(parse(text=LockGText("AFDLarge")));
  } else if (this$Type == "Griff") {
    XP = AFD$X;
    eval(parse(text=GetGText("AFDS")));
    t1 = proc.time();
    Griff = GriffingsGCAAnalysis(Y = AFDS$Y, AFDS$Listjk);
    t2 = proc.time();
    this$MyOA$UpdateTables(meanVector = Griff$meanVector,
      sdVector = Griff$sdVector,
      TrueParam= TrueParametersList, Times=t2-t1, lmOb = Griff$lmOb, 
      verbose = UpdateVerbose, GX = AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2= AllXP, RealX = AFD$X, RealY = AFDS$Y,
      StartOnSimID = StartOnSimID);
    eval(parse(text=LockGText("AFDS")));
  } else if (this$Type == "Diallelhglm") {
    eval(parse(text=GetG0Text("AFD", S=1)));
    eval(parse(text=GetG0Text("t1", S=1))); eval(parse(text=GetG0Text("t2", S=1)));
    eval(parse(text=GetG0Text("HitSimPreds", S=1))); eval(parse(text=GetG0Text("TrueParametersList", S=1)));
    eval(parse(text=GetG0Text("AllXP", S=1))); eval(parse(text=GetG0Text("APredMean", S=1)));    
    t1 = proc.time();
    AHg = AFDhglm(AFD$AllDiallelObs[[1]]);
    t2 = proc.time();
    meanVector = c(AHg$sum.table[,1]); 
    AsHg = summary(AHg);
    sdVector = c(AHg$sum.table[,2])
    eval(parse(text=LockGText("AsHg")));
    eval(parse(text=LockGText("AsHg")));
    this$MyOA$UpdateTables(meanVector = meanVector,
      sdVector = sdVector,
      TrueParam= TrueParametersList, Times=t2-t1, lmOb = NULL, 
      hglmOb = AHg, 
      verbose = UpdateVerbose, GX = AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds,  GX2= AllXP, 
      RealX = AFD$AllDiallelObs[[1]]$X, RealY = AFDS$Y,
      StartOnSimID = StartOnSimID);

  } else if (this$Type == "GriffSat") {
    eval(parse(text=GetGText("AFDS")));
    t1 = proc.time();
    GriffSat = GriffingsSATME(Y = AFDS$Y, AFDS$Listjk, AFD$X);
    t2 = proc.time();
    this$MyOA$UpdateTables(meanVector = GriffSat$meanVector,
      sdVector = GriffSat$sdVector,
      TrueParam= TrueParametersList, Times=t2-t1, lmOb = GriffSat$lmOb, 
      verbose = UpdateVerbose, GX = AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds,  GX2= AllXP, RealX = AFD$X, RealY = AFDS$Y,
      StartOnSimID = StartOnSimID);
    eval(parse(text=LockGText("AFDS")));             
  } else if (this$Type == "DiallelLargeOutlier") {
    eval(parse(text=GetG0Text("dfStart",S=1)));
    eval(parse(text=GetG0Text("mStart",S=1)));
    eval(parse(text=GetG0Text("AFDS",S=1)));
    eval(parse(text=GetG0Text("t1", S=1)));
    eval(parse(text=GetG0Text("t2", S=1)));
    XP = AFD$X;
    ## Verbose = 4;
    eval(parse(text=GetG0Text("Verbose")));
    if (is.logical(Verbose)) {
      if (Verbose == FALSE) {Verbose = -2;} else {Verbose = 2;}
    }
    if (Verbose > 0) {
      print(paste("DiallelLargeOutlier, starting for df = ", this$dfTNoise, sep=""));
      flush.console();
    }
    ##print(paste("Let's TryCatch an Error ", sep=""));flush.console();
    ##tryCatch("Trying Not to blow up!"); flush.console(); return;
    AFDOO = FullDiallelAnalyze(Y = AFDS$Y, 
      SexVector = AFDS$SexVector,
      Listjk = AFDS$Listjk, dfStart = dfStart, mStart = mStart,
      InFixedEffects = AFDS$FixedEffects,
      InRandomEffects = AFDS$RandomEffects, dfTNoise = this$dfTNoise,
      Verbose = Verbose,  MyFullDiallelName = "AFDOO: Open AFD");
    if (Verbose > 0) {
      print(paste("DiallelLargeOutlier, Well, we got AFDOO", sep=""));
      flush.console();
    }   
    eval(parse(text=GetG0Text("AllExampleModels")));
    INeedModels = AllExampleModels[c(LModel,2),];
    if (Verbose > 0) {
      print("  Current INeedModels is : "); flush.console();
      print(INeedModels); print(" Okay? "); flush.console();
    }
    eval(parse(text=LockGText("AllExampleModels")));
    eval(parse(text=GetG0Text("start")));
    ##eval(parse(text=SetGText("AFD")));
    if (Verbose > 0) {
      print("  Setting up AFDOO Methods"); flush.console();
    }
    if (Verbose > 0) {
      print(paste("DiallelLargeOutlier, SetupAnalysisMethods", sep=""));
      flush.console();
    }    
    if (is.null(AFDOO)) {
      print("Uh Oh, AFDOO is NULL right before setup analysis methods"); flush.console();
    }
    if (Verbose > 0) {
      print(paste("DiallelLargeOutlier, here we go with setup!", sep="")); flush.console();
    }
    SetupAnalysisMethods(AFDOO, ModelsList = INeedModels, Sigma = 1,
      numChains = 5, lengthChains = 5000, dfTNoise = this$dfTNoise,
      Verbose=Verbose);
    if (Verbose > 0) {
      print("We escaped setup AFDOO, setup chains now"); flush.console();
    }
    if (Verbose > 1) {
      print(paste("NamesAFDOO after Setup are : ", paste(names(AFDOO), collapse=", "),
        sep="")); flush.console();
      print(paste("Specifically, AFDOO$AllDiallelObs has length ",
        length(AFDOO$AllDiallelObs), sep=""));  flush.console();
    }
    if (is.null(AFDOO$AllDiallelObs)) {
      print(paste("Error, AFDOO has no AllDiallelObs length!", sep="")); flush.console();
    }
    try(SetupChains(AFDOO$AllDiallelObs[[1]], 5, 4000))
    if (Verbose > 0) {
      print("We escaped setup AFDOO Chains, RunChainsNow"); flush.console();
    }  
    if (is.null(AFDOO$AllDiallelObs[[1]]$CodaChains) ||
      length(AFDOO$AllDiallelObs[[1]]$CodaChains) <= 0) {
      print("No go, AFDOO Chains are null!"); flush.console();  
    }
    t1 = proc.time();
    eval(parse(text=GetGText("KillVerboseChains")));
    if (KillVerboseChains == TRUE) {
      try(RunChainsCC(AFDOO$AllDiallelObs[[1]], AFD = AFDOO, ChainIter=-1, Verbose = -4));
    } else {
      try(RunChainsCC(AFDOO$AllDiallelObs[[1]], AFD = AFDOO, ChainIter=-1));    
    }
    t2 = proc.time();
    if (is.null(AFDOO$AllDiallelObs[[1]]$CodaChains)) {
      print("Effit, no chains to AFDOO, returning!"); flush.console();
      return;
    }
 
    if (Verbose > 0) {
      print(paste("DiallelLargeOutlier, MXTable make Now", sep=""));
      flush.console();
    }
    DICFeed = c(0,0,0,0);
    end = length(AFDOO$AllDiallelObs[[1]]$CodaChains[[1]][,1])
    if (Verbose > -1) {
      print("DiallelLargeOutlier: try to make MXTable"); flush.console();
    }
    MXTable = NULL;
    try(MXTable <- MXChain(CreateMatrixMX(AFDOO$AllDiallelObs[[1]]), 
      AFDOO$AllDiallelObs[[1]]$CodaChains));
    if (is.null(MXTable)) {
      print("Tried to make MXTable but it failed"); flush.console();
    }
    if (!exists("XP")) {
      XP = AFD$X;
    }   
    if (is.null(XP)) {
      print("Error: XP is NULL");
    }
    if (Verbose > 0) {
      print(paste("dim(XP) = (", paste(dim(XP), collapse=", "), ")", sep=""));
      flush.console();
    }
    if (Verbose > -1) {
      print("Going into UpdateTables DiallelLarge Outlier"); flush.console();
    }
    this$MyOA$UpdateTables(OutCoda=AFDOO$AllDiallelObs[[1]]$CodaChains,
      TrueParam= TrueParametersList, Times=t2-t1, verbose = UpdateVerbose,
      DICFeed = DICFeed, GX = AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2 = AllXP, start=start, RealY = AFD$Y, end = end,
      RealX = AFDOO$X,
      StartOnSimID = StartOnSimID);  
    this$MyOAMX$UpdateTables(OutCoda=MXTable,
      TrueParam= TrueParametersList, Times=t2-t1, verbose = UpdateVerbose,
      DICFeed = DICFeed, GX = AllXP, TruePredMeans = APredMean,
      HitSimPreds = HitSimPreds, GX2 = AllXP, start=start, RealX = AFDOO$X,
      RealY = AFD$Y, end=end, StartOnSimID =StartOnSimID);
    if (Verbose > 0) {
      print(paste("DiallelLargeOutlier, Hey we finished, df = ", this$dfTNoise, sep=""));
      flush.console();
    }   
    eval(parse(text=LockGText("MyiiExampleModels")));
    
    AText = paste( "AFDLarge", this$dfTNoise, " = Copy(AFDOO);
      TwoText = \"AFDLarge", this$dfTNoise, "\";", sep="");
    try(eval(parse(text=GetG0Text(TwoText))));
    try(eval(parse(text=AText)))
    try(eval(parse(text=LockGText(TwoText))));
  }
  if (Verbose == TRUE || Verbose > 1) {
    print(paste("RunSim Type = ", this$Type, "Now Leaving",sep="")); flush.console();
  }
  eval(parse(text=LockRSIText("AFD")));
});

##################################################
## Simulates a bunch of diallels, fits Sigma for those diallels
## 
RunHGLMForSigma <- function(NSigmas = 150) {
  Verbose = 0;
  SigmaReturn = rep(0, NSigmas);
  SetupAFDS(NoSave = TRUE, Verbose = -1)
  RunASimulation(JustStart = TRUE, Verbose=-1,NoMySimmer = TRUE);
  SetupAFD(Partial=c(1,2), Verbose = -1);
  eval(parse(text=GetG0Text("AFDS", S=1)));
  eval(parse(text=GetG0Text("AFD",S=1)))
  for (ii in 1:length(SigmaReturn)) {
    SimValues(AFDS, MiceOnly = TRUE);
    AFD$Y = AFDS$Y;
    eval(parse(text=GetG0Text("AFD"))); 
    t1 = proc.time();
    AHg = AFDhglm(AFD$AllDiallelObs[[1]]);
    t2 = proc.time();
    meanVector = c(AHg$sum.table[,1]); 
    ATT = (1:length(rownames(AHg$sum.table)))[(rownames(AHg$sum.table) %in% c("Sigma","Sigma:1"))]
    SigmaReturn[ii] = meanVector[ATT[1]];
    ##try(rm("AFD", envir = globalenv()));  AFD = NULL;
    ##eval(parse(text=SetGText("AFD", S=1)));
    ##try(rm("AFDS", envir =globalenv())); AFDS = NULL;
    ##eval(parse(text=SetGText("AFDS", S=1)));
  }
  return(SigmaReturn);
}
SetupAFD <- function(Partial = NULL,Verbose = -10) {
  if (is.numeric(Verbose) && Verbose == -10) {
    eval(parse(text=GetG0Text("Verbose", S=1)));
  }
  if (Verbose > 0) {
    if (!is.null(JustStart) && JustStart == TRUE) {
      print("JustStart = TRUE, so Simmers should quit at end"); flush.console();
    } else {
      print("JustStart = FALSE, so Simmers won't quit"); flush.console();
    }
  }
  eval(parse(text=GetG0Text("MySimmer", S=1)));
  if (!(is.numeric(MySimmer) && MySimmer == 0) &&
    !is.null(MySimmer)) {
    NameN <- NamesTypes(MySimmer);
  } else {
    NameN = c("Diallelhglm", "DiallelLarge");
  }
  dfTNoise = -1;
  if (any(NameN == "DiallelLarge")) {
    ii = min((1:length(NameN))[NameN == "DiallelLarge"])
    if (!(is.numeric(MySimmer) && MySimmer == 0) &&
    !is.null(MySimmer)) {
      if (MySimmer$SimL[[ii]]$dfTNoise > 0) {
        dfTNoise = MySimmer$SimL[["DiallelLarge"]]$dfTNoise;
      }  
    }
  }
  if (exists("AFD", globalenv())) {
    eval(parse(text=GetG0Text("AFD", S=1)));
    try(rm("AFD", envir=globalenv())); AFD = NULL;
    eval(parse(text=SetGText("AFD", S=1)));
  }   
  AFD = NULL;
  if (Verbose == 0) {
    if (!(is.numeric(MySimmer) && MySimmer == 0) &&
      !is.null(MySimmer)) {
      if (!is.null(MySimmer$Verbose)) {  Verbose = MySimmer$Verbose; }
    }
  }
  if (Verbose > 0) {
    print("Trying to get, unlock AFD binding"); flush.console();
  }
  try(eval(parse(text=GetG0Text("AFD", S=1))));
  if (Verbose > 0) {
    print("Well we got AFD"); flush.console();
  }
  eval(parse(text=GetG0Text("AFDS",S=1)));     
  eval(parse(text=GetG0Text("AllExampleModels",S=1)));
  AFD  <- FullDiallelAnalyze(Y = AFDS$Y, 
    SexVector = AFDS$SexVector,
    Listjk = AFDS$Listjk, dfStart = dfStart, mStart = mStart,
    InFixedEffects = AFDS$FixedEffects,
    InRandomEffects = AFDS$RandomEffects, dfTNoise = dfTNoise,
      "AFD - Analyszer FD Object");
  if (Verbose > 0) {
    print("Constructed a new AFD"); flush.console();
  }
  eval(parse(text=SetGText("AFD",S=1)));
  ##eval(parse(text=SetGText("AFD",S=1)));
  if (Verbose > -1) {
    eval(parse(text=GetG0Text("MyCheckToTarget")));
    print(paste(
      MyCheckToTarget, " to go: We just constructed a new FullDiallel Analyze",sep=""));
     flush.console();
    print(AFD);
  }
  if (Verbose > 0) {
    print("  Setting up AFD Methods"); flush.console();
  }
  if (is.null(Partial) || any(Partial < 0) || any(Partial > NROW(AllExampleModels))) {
    Partial = (1:NROW(AllExampleModels));
  }
  SetupAnalysisMethods(AFD, AllExampleModels[Partial,], Sigma = 1,
    numChains = 3, lengthChains = 2000, dfTNoise = dfTNoise);
  eval(parse(text=SetGText("AFD")));
}

#####
### Code Runs "MySimmers" List set to run the algorithms that fit the simulation in AFDS;
setMethodS3("RunSims", "Simmers", function(this, JustStart = FALSE, Verbose = 0,...) {

  if (Verbose > 0) {
    if (!is.null(JustStart) && JustStart == TRUE) {
      print("JustStart = TRUE, so Simmers should quit at end"); flush.console();
    } else {
      print("JustStart = FALSE, so Simmers won't quit"); flush.console();
    }
  }
  NameN <- NamesTypes(this);
  dfTNoise = -1;
  if (any(NameN == "DiallelLarge")) {
    ii = min((1:length(NameN))[NameN == "DiallelLarge"])
    if (this$SimL[[ii]]$dfTNoise > 0) {
      dfTNoise = this$SimL[["DiallelLarge"]]$dfTNoise;
    }
  }
  AFD = NULL;
  if (Verbose == 0) {
    if (!is.null(this$Verbose)) {  Verbose = this$Verbose; }
  }
  if (Verbose > 0) {
    print("Trying to get, unlock AFD binding"); flush.console();
  }
  try(eval(parse(text=GetG0Text("AFD", S=1))));
  if (Verbose > 0) {
    print("Well we got AFD"); flush.console();
  }
  eval(parse(text=GetG0Text("AFDS")));     
  eval(parse(text=GetG0Text("AllExampleModels")));
  AFD  <- FullDiallelAnalyze(Y = AFDS$Y, 
    SexVector = AFDS$SexVector,
    Listjk = AFDS$Listjk, dfStart = dfStart, mStart = mStart,
    InFixedEffects = AFDS$FixedEffects,
    InRandomEffects = AFDS$RandomEffects, dfTNoise = dfTNoise,
      "AFD - Analyszer FD Object");
  if (Verbose > 0) {
    print("Constructed a new AFD"); flush.console();
  }
  eval(parse(text=SetGText("AFD",S=1)));
  if (Verbose > -1) {
    eval(parse(text=GetG0Text("MyCheckToTarget",S=1)));
    print(paste(
      MyCheckToTarget, " to go: We just constructed a new FullDiallel Analyze",sep=""));
     flush.console();
    print(AFD);
  }
  if (Verbose > 0) {
    print("  Setting up AFD Methods"); flush.console();
  }
  SetupAnalysisMethods(AFD, AllExampleModels, Sigma = 1,
    numChains = 3, lengthChains = 2000, dfTNoise = dfTNoise);
  if (Verbose > 0) {
    print("We escaped setup AFD"); flush.console();
  }
  eval(parse(text=SetGText("AFD")));
  eval(parse(text=LockGText("AFDS")));     
  eval(parse(text=LockGText("AllExampleModels")));
  XP = AFD$X;
  eval(parse(text=SetGText("XP", S=1)));
  if (Verbose > 0) {
    if (!is.null(JustStart) && JustStart == TRUE) {
      print("JustStart = TRUE, so Simmers Really will quit now"); flush.console();
    } else {
      print("JustStart = FALSE, so Simmers won't quit"); flush.console();
    }
  }
  if (!exists("JustStart")) { JustStart = TRUE; }
  if (!is.null(JustStart) && JustStart == TRUE) {
    print("JustStart = TRUE, Simmers IS Quitting!"); flush.console();
    return();
    print("JustStart = TRUE, We did quit right?"); flush.console();
  }
  if (any(NameN == "DiallelDICMin")) {
    if (Verbose > 0) {
      print("For AFDs sake, running all chains"); flush.console();
    }
    eval(parse(text=GetG0Text("Rt1",S=1)))
    eval(parse(text=GetG0Text("Rt2",S=1)))
    Rt1 = proc.time();
      RunChains(AFD);
    Rt2 = proc.time();  
    try(eval(parse(text=GetG0Text("MyDIC",S=1))));
    MyDIC = PrintDICCAll(AFD, Verbose = 0);
    DICMin = sort(MyDIC[,7], index=TRUE)$ix[1];
    eval(parse(text=LockGText("MyDIC")));    
    eval(parse(text=LockGText("DICMin")));

    eval(parse(text=LockGText("Rt1")));
    eval(parse(text=LockGText("Rt2")));
  } else {
    if (Verbose > 0) {
      print(" DiallelDICMin not necessary: not running it! "); flush.console();
    }
  }
  eval(parse(text=LockGText("AFD")));
  if (!is.null(this$Verbose) && this$Verbose > 0) {
    print("RunSims: We're about to run the Sims we need"); flush.console();
  }
  if (JustStart == TRUE) { return(); }
  if (JustStart == FALSE) {
  for (ii in 1:length(this$SimL)) {
    eval(parse(text=GetG0Text("OnSimii", S=1)));
    OnSimii = ii;
    eval(parse(text=SetGText("OnSimii", S=1)));
    RunSim(this$SimL[[ii]], JustStart=JustStart);  
  }
  }
  
  ##this$WriteAndClear();
  if (exists("AFD", globalenv())) {
    eval(parse(text=GetG0Text("AFD", S=1)));
    try(rm("AFD", envir=globalenv())); AFD = NULL;
    eval(parse(text=SetGText("AFD", S=1)));
  }   
  eval(parse(text=GetG0Text("AFD")));
  AFD = NULL;
  eval(parse(text=LockGText("AFD")));
  X = NULL; Y = NULL;
  eval(parse(text=LockGText("X")));
  eval(parse(text=LockGText("Y")));
});

setMethodS3("NamesTypes", "Simmers", function(this,...) {
  NameN = rep("", length(this$SimL));
  for (ii in 1:length(NameN)) {
    NameN[ii] = this$SimL[[ii]]$Type;
  }
  return(NameN);
});


.DefaultModelsIn <- c("Griff", "GriffSat", "DiallelLarge",
  "DiallelDICMin", "DiallelTRUE", "DiallelSpike","Diallelhglm");
  

PredMeanNames=NULL; PredMeanLength = 0;

setMethodS3("WriteAndClear", "Simmers", function(this,...) {
  RTM = rep(0, length(this$SimL));
  for (ii in 1:length(this$SimL)) {
    RTM[ii] = -1;
    try(RTM[ii] <- WriteAndClear(this$SimL[[ii]]));
    if (RTM[ii] == -1)  {
       print(paste("ERROR: WriteAndClear Fails on SimL = ", this$SimL[[ii]]$Type, sep=""));
       flush.console();
    }
  }
  return(min(RTM));
});
setMethodS3("WriteAndClear", "ASim", function(this,...) {
  if (!is.null(this$MyOA)) {
    A1 = -1;
    try(A1 <- WriteAndClear(this$MyOA)); 
    if (A1 == -1) {
      print(paste("ERROR: Write and Clear ASim Fails on Type = ", this$Type, sep=""));
      flush.console();
    }
  }
  if (!is.null(this$MyOAMX)) {
    A2 = -1;
    try(A2 <- WriteAndClear(this$MyOAMX));
    if (A2 == -1) {
      print(paste("ERROR: Write and Clear ASim MX Fails on Type = ", this$Type, sep=""));
      flush.console();
    }
    if (A2 < A1) { return(A2); }
  }
  return(A1);
});
setMethodS3("SetupOAs", "Simmers", function(this,...) {
  if(!is.null(this$Verbose) && this$Verbose > 1) {
    print("SetupOAs:  Beginning to run"); flush.console();
  }
  for (ii in 1:length(this$SimL)) {
    if(!is.null(this$Verbose) && this$Verbose > 1) {
      print("SetupOAs:  Running SetupMyOA"); flush.console();
    }
    SetupMyOA(this$SimL[[ii]]);
  }
  return(1);
});
setMethodS3("SetupMyOA", "ASim", function(this,...) {
  if (!exists("TrueParametersList", globalenv()) ) {
    print(paste("SetupMyOA, Type = ", this$Type,
      " Give me TrueParametersList", sep="")); flush.console();
  }
  eval(parse(text=GetG0Text("MySimUName")));
  if (!exists("MySimUName") || (length(MySimUName) == 1 && 
    is.numeric(MySimUName) && MySimUName == 0) ) {
    MySimUName = "AnonySim"
    print(paste("SetupMyOA, Type = ", this$Type, 
      " Should have MySimUName", sep="")); flush.console();
  }
  cBB = rbind(c("Griff", "Griffings", "GCA Additive", "GCA"),
   c("GriffSat", "Griffings Saturated", "GCA/SCA", "GCA/SCA"),
   c("Diallelhglm", "Diallel HGLM", "Hglm full", "Hglm All"),
   c("DiallelLarge", "Full Model", "Full", "All"),
   c("DiallelDICMin", "DIC Min", "DIC Min", "Min"),
   c("DiallelTRUE", "True Model", "True", "True"),
   c("DiallelSpike", "Spike", "Spike", "Spike"),
   c("DiallelLargeOutlier", "Full Model", "Full", "L-t. :"),
   c("DiallelSpikeOutlier", "Spike", "Spike", "Spike-t. :"));
   
  IDI = (1:length(cBB[,1]))[cBB[,1] == this$Type];
  MethodName = cBB[IDI,2]; ModelName =cBB[IDI,3];
  ModelSubName = cBB[IDI,4];
  if (is.numeric(this$dfTNoise) && this$dfTNoise > 0) {
    ModelSubName = paste(ModelSubName, ", $\\mbox{\\small{d.f.}}=", round(this$dfTNoise,1), "$", sep="");
  }

  eval(parse(text=GetGText("PredMeanNames")));
  eval(parse(text=GetGText("PredMeanLength")));
  eval(parse(text=GetGText("IdentifierList")));
  eval(parse(text=GetG0Text("TrueParametersList")))
  this$MyOA = NULL;
  if (this$Type %in% c("Griff", "GriffSat", "Griffings",
    "GriffingsSaturated", "Diallelhglm", "hglm")) {
    try(this$MyOA <- OutLMAnalyses(TargetLength=TARGET,
      SampleBeta = TrueParametersList, FileDir=this$AllDir2, quantile = .95, INTIN=0,
      SimuName = MySimUName, IdentifierList = IdentifierList,
      MethodName = MethodName, PredMeanNames = PredMeanNames, PredMeanLength=PredMeanLength,
      ModelName = ModelName, ModelSubName=ModelSubName,
      NumSimPred = NumSimPred,
      PredSimMeanNames= PredSimMeanNames, PreferMeanMedian=this$PreferMeanMedian, PreferSmpValMIPVal=this$PreferSmpValMIPVal));   
  } else {
    try(this$MyOA <- OutCodaAnalyses(TargetLength=TARGET,
      SampleBeta = TrueParametersList, FileDir=this$AllDir2, quantile = .95, INTIN=0,
      SimuName = MySimUName, IdentifierList = IdentifierList,
      MethodName = MethodName, PredMeanNames=PredMeanNames, PredMeanLength=PredMeanLength,
      ModelName = ModelName, ModelSubName=ModelSubName,
      NumSimPred = NumSimPred, PredSimMeanNames= PredSimMeanNames,
      PreferMeanMedian=this$PreferMeanMedian,
      PreferSmpValMIPVal=this$PreferSmpValMIPVal));
  }
  if (is.null(this$MyOA)) {
    print(paste("SetupMyOA, Type = ", this$Type, "  error, could not make MyOA", sep=""));
    flush.console();
  }
  this$MyOAMX = NULL;
  if (this$Type %in% c("DiallelLarge",
      "DiallelDICMin", "DiallelTRUE", "DiallelSpike", "DiallelLargeOutlier", "DiallelSpikeOutlier")) {
    try(this$MyOAMX <- OutCodaAnalyses(TargetLength=TARGET,
      SampleBeta = TrueParametersList, FileDir=paste(this$AllDir2, "MX", sep=""),
      quantile = .95, INTIN=0,
      SimuName = MySimUName, IdentifierList = IdentifierList,
      MethodName = MethodName, PredMeanNames=PredMeanNames, PredMeanLength=PredMeanLength,
      ModelName = ModelName, ModelSubName=ModelSubName,
      NumSimPred = NumSimPred,
      PredSimMeanNames= PredSimMeanNames,PreferMeanMedian=this$PreferMeanMedian,
      PreferSmpValMIPVal=this$PreferSmpValMIPVal));
      if (is.null(this$MyOAMX)) {
        print(paste("SetupMyOA, Type = ", 
        this$Type, "  error, could not make MyOAMX", sep=""));
        flush.console();
      }
  }

  eval(parse(text=LockGText("PredMeanNames")));
  eval(parse(text=LockGText("PredMeanLength")));
  eval(parse(text=LockGText("IdentifierList"))); 
});

FindExampleModels <- function() {
  print("Rerunning Find Example Models"); flush.console();
  eval(parse(text=GetG0Text("AFDS",S=1)));
  eval(parse(text=GetG0Text("AllExampleModels", S=1)));
  if (is.null(AFDS)) {
    print("FindExampleModels: AFDS is too null to work!"); flush.console();
  }
  ExampleModelsList <- matrix(c(AFDS$ADiallelOb$.ajModel, 
    AFDS$ADiallelOb$.MotherModel, AFDS$ADiallelOb$.CrossModel,
    AFDS$ADiallelOb$.SexModel, AFDS$ADiallelOb$.BetaInbredLevel, 
    AFDS$ADiallelOb$.BetaInbredTimesSex), 1, 6);
  MyF = AllExampleModels[,1] == ExampleModelsList[1];
  for (jj in 2:length(ExampleModelsList)) {                     
    MyF = MyF & ( AllExampleModels[,jj] == ExampleModelsList[jj]);
  }
  eval(parse(text=GetG0Text("MyiiExampleModels")));
  MyiiExampleModels <- (1:length(MyF))[ MyF == TRUE];
  if (length(MyiiExampleModels) == 0) {
    print("MyiiExampleModelsError, ExampleModelsList does not include me!");
    print(AllExampleModels);
    print(paste("But Real One: (", paste(ExampleModelsList, collapse=", "), ")",
    sep="")); flush.console();
  } else {
    print(paste("Find Example Models finished, found ", MyiiExampleModels, 
      sep="")); flush.console();
  }
  eval(parse(text=LockGText("MyiiExampleModels")));
  return(MyiiExampleModels);

}

SetupAFDS <- function(Verbose = 1, ModelsIn = NULL, MaxReadLength = 0,
  NoSave = FALSE) {
if (is.null(ModelsIn)) {
  if (exists("ModelsIn", globalenv()) ) {
    eval(parse(text=GetGText("ModelsIn")))
  } else {
    ModelsIn = .DefaultModelsIn;
  }
}
if (Verbose > 0) { print("Making first Simulation"); flush.console(); }

eval(parse(text=GetG0Text("nReps",S=1)));
if (nReps == 0) { nReps = 2; }
   NumReps = nReps;  NumRepetitions = nReps;
eval(parse(text=SetGText("NumReps",S=1)));
eval(parse(text=SetGText("NumRepetitions",S=1)));
             
             

if (!exists("InFixedEffects", globalenv()) ) { print("InFixedEffects Does not exist"); InFixedEffects=NULL; 
}  else {
  eval(parse(text=GetGText("InFixedEffects",S=1)));
}
if (!exists("InRandomEffects", globalenv()) ) { print("InRandomEffects Does not exist"); InRandomEffects=NULL; 
}  else {
  eval(parse(text=GetGText("InRandomEffects",S=1)));
}
if (!exists("GenderOn", globalenv()) ) { print("GenderOn Does not exist"); GenderOn=FALSE; 
}  else {
  eval(parse(text=GetGText("GenderOn",S=1)));
}
if (!exists("NumRepetitions", globalenv())  && !exists("nReps", globalenv())) {
  print("NumRepetitions Does not exist"); NumRepetitions=NULL; 
}  else if (exists("nReps", globalenv())) {
  eval(parse(text=GetG0Text("nReps", S=1)));
  NumRepetitions = nReps;
  if (!is.numeric(NumRepetitions) || NumRepetitions <= 1) {
    NumRepetitions = 1;
  }
  eval(parse(text=SetGText("NumRepetitions", S=1)))
} else {
  eval(parse(text=GetG0Text("NumRepetitions",S=1)));
  if (!is.numeric(NumRepetitions) || NumRepetitions <= 1) {
    NumRepetitions = 1;
  }
}
if (!exists("InBalance", globalenv()) ) { print("InBalance Does not exist"); InBalance=NULL; 
}  else {
  eval(parse(text=GetGText("InBalance")));
}
flush.console();

  eval(parse(text=GetG0Text("OnlyNeedTablesList", S=1)));
  if (!is.null(OnlyNeedTablesList) && is.numeric(OnlyNeedTablesList) &&
    OnlyNeedTablesList[1] == 0) {
    OnlyNeedTablesList = NULL;
  }

  if (Verbose > 0) {print("Retrieving First AFDS"); flush.console();}

  eval(parse(text=GetG0Text("AFDS", "globalenv()",S=1)));

  if (Verbose > 0 && is.null(AFDS) || (length(AFDS) == 1 && 
    is.numeric(AFDS) && AFDS == 0)) {
    print("That AFDS was null!"); flush.console();
  }

  eval(parse(text=GetG0Text("SimDfTNoise", S=1)));

  eval(parse(text=GetG0Text("Sigma", "globalenv()", S=1)));
  eval(parse(text=GetG0Text("SSigmaSq", "globalenv()", S=1)));
  if (SSigmaSq > 0) {
    Sigma = SSigmaSq;  names(Sigma) = "Sigma:1"
  } else if (Sigma > 0) {
    SSigmaSq = Sigma;  eval(parse(text=LockGText("SSigmaSq")));
    print(paste("Warning, SSigmaSq reset! to ", SSigmaSq, sep="")); flush.console();
  }
  eval(parse(text=LockGText("Sigma",S=1)));
  if (Verbose > 0) {
   print(paste("About to create AFDS, GenderOn = ", GenderOn, sep=""));
   flush.console();
  }
  AFDS <- FullDiallelSimulate(InFixedEffects = InFixedEffects,
    InRandomEffects = InRandomEffects, mRandomEffects = 20,
    dfRandomEffects = 5, tauFixedEffects = 20, YesSex = GenderOn, NumRepetitions = NumRepetitions, 
    InBalance = InBalance, dfTNoise = SimDfTNoise,  MyFullDiallelName = "AFDS: Simulator"
  );
  eval(parse(text=GetG0Text("SimIDCode", S=1)))
  eval(parse(text=GetG0Text("SimIDAllName", S=1)));
  eval(parse(text=GetG0Text("MySimUName", S=1)));
  eval(parse(text=GetG0Text("StartOnSimID", S=1)));  
  ttOn = proc.time();
  StartOnSimID = paste("T", paste(as.numeric(ttOn), collapse="t"), sep="");
  AFullSimID = paste(MySimUName, StartOnSimID, sep="");
  eval(parse(text=SetGText("StartOnSimID", S=1)))
  eval(parse(text=GetG0Text("AllDir", S=1)));
  dir.create(paste(AllDir, "//", "Simulations", sep=""), showWarnings=FALSE);
  if (NoSave != TRUE) {
  try(save(AFDS, file = paste(AllDir, "//", "Simulations//AFDS", AFullSimID, ".RData", sep="")));
  try(save(Y = AFDS$Y, Beta = AFDS$ADiallelOb$Beta, Listjk = AFDS$Listjk,
    is.female, SexVector = AFDS$SexVector,
  paste(AllDir, "//", "Simulations//SimVals", AFullSimID, ".RData", sep="")));
  }
  
  if (Verbose > 1) {
   print(paste("Setup AFDS: About to default Simulate Param ", sep=""));
   flush.console();
  }
  defaultSimulateParam(AFDS);
  AFDS$Sigma = Sigma;
  if (is.null(InRandomEffects) && is.null(InFixedEffects)) {
    if (Verbose > 1) {
     print(paste("InRandomEffects Null and InFixedEffects Null, but Gender On =  ", GenderOn, sep=""));
     flush.console();
    }
    SetupFilledSimulatedListjk(AFDS, NumRepetitions = NumRepetitions, 
      YesSex = GenderOn, InBalance = InBalance, dfTNoise = SimDfTNoise);
  }
  

  eval(parse(text=GetG0Text("Mu",S=1)));
  eval(parse(text=GetG0Text("GenderMu",S=1)));
  eval(parse(text=GetG0Text("BetaInbred",S=1)));
  eval(parse(text=GetG0Text("BetaInbredTimesGender",S=1)));
  eval(parse(text=GetG0Text("IdentifierList",S=1)));
  attach(IdentifierList);
  BetaInbredLevel = 0;
  if (BetaInbred != 0) { BetaInbredLevel = 1; }
  BetaInbredTimesSex = 0;
  if (BetaInbredTimesGender != 0) { BetaInbredTimesSex = 1; }

  if (Verbose > 0) {
    print("Setting up AFDSSimulation Model with inputs"); flush.console();
  }

  if (Verbose > 0) {
    print("Setting Beta Now"); flush.console();
  } 
  eval(parse(text=GetG0Text("SetBetaMethod",S=1)));
  if (exists("SetBetaMethod") && (SetBetaMethod > 0  || SetBetaMethod == TRUE)) {
    if (Verbose > 0) {
      print(" Getting Betajs List"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierBetaList", "globalenv()")));
    if (Verbose > 0) {
      print(" Getting IdentifierList"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierList", "globalenv()")));
    MyRDD = BayesDiallel:::.DefaultAllRandomVariables;
    MyRD2 = strsplit( MyRDD, ":");
    for (ii in 1:length(MyRD2)) { MyRDD[ii] = paste(unlist(MyRD2[[ii]]), collapse=""); }
    RText = 
     paste("SetBeta(AFDS, Mu=Mu, GenderMu = GenderMu, BetaInbred=BetaInbred, 
       BetaInbredTimesGender = BetaInbredTimesGender,
       StrainSequence = StrainSequence,
       ", paste( MyRDD, "Sequence = ", MyRDD, "Vector", collapse=", ", sep=""),"
       , Sigma = SSigmaSq );", sep="");
    if (Verbose > 2) {
      print("Now about to Set Beta with RText = ");
      print(cat(RText)); flush.console();
    }
    StrainSequence = rep(0, numj);
    if (Verbose > 2) {
      print(paste("StrainSequence = ", paste(StrainSequence, collapse=", "))); flush.console();
    }
    eval(parse(text=RText));
##    SetBeta(AFDS, Mu = Mu, GenderMu = GenderMu, BetaInbred =BetaInbred, BetaInbredTimesGender = BetaInbredTimesGender,
##      StrainSequence = ajVector, MotherSequence = MotherVector, 
##      Sigma=SSigmaSq);
  } else if (exists("SetBetaMethod") && (SetBetaMethod == FALSE || SetBetaMethod == 0)) {
    if (Verbose > 0) {
      print("Setup AFDS: Getting IDTauList Now!"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierTauList", "globalenv()")));
    if (Verbose > 0) {
      print("Setup AFDS: Getting IdentifierList Now!"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierList", "globalenv()")));
    if (Verbose > 0) {
      print("Setup AFDS: SetupSimulate Method"); flush.console();
    }
    SetupSimulateMethod(AFDS, ajModel = ajModel, MotherModel = MotherModel, 
      CrossModel = CrossModel, SexModel = SexModel, 
      BetaInbredLevel = BetaInbredLevel, 
      BetaInbredTimesSex = BetaInbredTimesSex); 
    if (Verbose > 0) {
      print("Setup AFDS: Set Tau now"); flush.console();
    }
    AFDS$SetTau(tauaj = tauaj,
      tauGenderaj = tauGenderaj, taumotherj = taumotherj, 
      tauGendermotherj = tauGendermotherj, taudominancej=taudominancej,
      tauGenderdomianncej = tauGenderdominancej, 
      tauSymCrossjk = tauSymCrossjk, tauGenderSymCrossjk = tauGenderSymCrossjk,
      tauASymCrossjkDkj = tauASymCrossjkDkj, 
      tauGenderASymCrossjkDkj = tauGenderASymCrossjkDkj,  
      tauAllCrossjk = tauAllCrossjk, tauGenderAllCrossjk = tauGenderAllCrossjk);    
  }  else {
    print("Set Beta Method did not exist, you set it yourself"); flush.console();
  }

  if (Verbose > 0) {
    print(" Now Assigning AFDS to the global environment "); flush.console();
  }
  eval(parse(text=SetGText("AFDS", "globalenv()", S=1)));
  
  
  if (Verbose > 0) {
    print("SetExampleModels now starting."); flush.console();
  }
  SetExampleModels(Verbose = Verbose -1);

  if (Verbose > 0) {
    print("Making first Large Simulation Model");
    flush.console();
  }
  eval(parse(text=GetG0Text("AllExampleModels", "globalenv()")));
  if (is.null(AllExampleModels) || length(AllExampleModels) == 1) {
    SetExampleModels();
    eval(parse(text=GetG0Text("AllExampleModels", "globalenv()",S=1)));
  }
  if (Verbose > 0) {
    print(" Now Checking out AFDSL "); flush.console();
  }  
  eval(parse(text=GetG0Text("AFDSL", "globalenv()",S=1)));
  if (Verbose > 0) {
    print("Create AFDSL: FullDiallelSimulate"); flush.console();
  }
  AFDSL <- FullDiallelSimulate(InFixedEffects = InFixedEffects,
   InRandomEffects = InRandomEffects, mRandomEffects = 20,
   dfRandomEffects = 5, tauFixedEffects = 20, YesSex = GenderOn, 
   NumRepetitions = NumRepetitions, InBalance = InBalance,  MyFullDiallelName = "AFDSL: Long variable default Simulator");
  eval(parse(text=SetGText("AFDSL", "globalenv()",S=1)));
  if (Verbose > 0) {
    print("Setting up default AFDSL parameters"); flush.console();
  }
  defaultSimulateParam(AFDSL);
  eval(parse(text=SetGText("AFDSL", "globalenv()",S=1)));
if (is.null(InRandomEffects) && is.null(InFixedEffects)) {
  SetupFilledSimulatedListjk(AFDSL, NumRepetitions = NumRepetitions, 
  YesSex = GenderOn, InBalance = InBalance);
}
  if (Verbose > 0) {
    print("Setting up default AFDSL Simulate Model from AllExample Models"); flush.console();
    print(paste("AllExampleModels[1,] = ", paste(AllExampleModels[1,], collapse=", "), sep=""));
    flush.console();
  }
  eval(parse(text=SetGText("AFDSL", "globalenv()")));
SetupSimulateMethod(AFDSL, ajModel = AllExampleModels[1,1], 
  MotherModel = AllExampleModels[1,2], CrossModel = AllExampleModels[1,3],
  SexModel = AllExampleModels[1,4], BetaInbredLevel = AllExampleModels[1,5],
  BetaInbredTimesSex = AllExampleModels[1,6], dfTNoise = SimDfTNoise,
  ParamVec = NULL);
  
FBeta = GiveAllModelsBeta(AFDSL, AllExampleModels)   
if (Verbose > 0) {
  print(paste("AFDSL: FBeta = ", paste(FBeta, collapse=", "), sep=""));
  flush.console();
}
FB = rep(0, length(FBeta));  names(FB) = FBeta;
FB[match(names(AFDS$ADiallelOb$Beta), names(FB))]  = AFDS$ADiallelOb$Beta;

FT = AFDSL$ADiallelOb$tau * 0; FTNOld = names(FT);
eval(parse(text=LockGText("AFDSL")));
  
names(FT) = paste("tau:", names(FT), sep="");
FT[match(x=names(AFDS$ADiallelOb$tau),
  ,table=FTNOld)]  = AFDS$ADiallelOb$tau;

SSSigmaSq = SSigmaSq; names(SSSigmaSq)  <- "Sigma:1";
Sigma <- SSigmaSq;  names(Sigma) = "Sigma:1";
eval(parse(text=LockGText("Sigma")));

eval(parse(text=GetG0Text("TrueParametersList",S=1)));
TrueParametersList <- c(FB, FT, Sigma); 
eval(parse(text=LockGText("TrueParametersList",S=1)));

if (Verbose > 0) {
  print("  Getting AFDSL To Set Means "); flush.console();
}
eval(parse(text=GetGText("AFDSL",S=1)));

if (!exists("InFixedEffects")) {
  eval(parse(text=GetG0Text("InFixedEffects", S=1)));
  if (length(InFixedEffects) == 1 && InFixedEffects[1] == 0) {
    InFixedEffects = NULL;
  }
}
if (!exists("InRandomEffects")) {
  eval(parse(text=GetG0Text("InRandomEffects",S=1)));
  if (length(InRandomEffects) == 1 && InRandomEffects[1] == 0) {
    InRandomEffects = NULL;
  }
} 
AFDSPred <- FullDiallelSimulate(InFixedEffects = InFixedEffects,
   InRandomEffects = InRandomEffects, mRandomEffects = 20,
   dfRandomEffects = 5, tauFixedEffects = 20, YesSex = GenderOn, 
   NumRepetitions = 1, InBalance = InBalance, MyFullDiallelName = "AFDSPred: Prediction AFDS");
  eval(parse(text=SetGText("AFDSL", "globalenv()",S=1)));
  if (Verbose > 0) {
    print("Setting up default AFDSL parameters"); flush.console();
  }
  defaultSimulateParam(AFDSPred);
  eval(parse(text=SetGText("AFDSPred", "globalenv()", S=1)));
if (is.null(InRandomEffects) && is.null(InFixedEffects)) {
  SetupFilledSimulatedListjk(AFDSPred, NumRepetitions = NumRepetitions, 
  YesSex = GenderOn, InBalance = InBalance);
}
  if (Verbose > 0) {
    print("Setting up default AFDSL Simulate Model from AllExample Models"); flush.console();
    print(paste("AllExampleModels[1,] = ", paste(AllExampleModels[1,], collapse=", "), sep=""));
    flush.console();
  }
  eval(parse(text=SetGText("AFDSPred", "globalenv()", S=1)));
SetupSimulateMethod(AFDSPred, ajModel = AllExampleModels[1,1], 
  MotherModel = AllExampleModels[1,2], CrossModel = AllExampleModels[1,3],
  SexModel = AllExampleModels[1,4], BetaInbredLevel = AllExampleModels[1,5],
  BetaInbredTimesSex = AllExampleModels[1,6], dfTNoise = SimDfTNoise,
  ParamVec = NULL);
eval(parse(text=GetG0Text("AllXP", S=1)))
AllXP = AFDSPred$X; 
  

if (Verbose > 1) {
  print("  Getting PredMeanNames  and PredMeanLength to Alter "); flush.console();
}
eval(parse(text=GetG0Text("PredMeanNames", S=1)));
eval(parse(text=GetG0Text("PredMeanLength",S=1)));
eval(parse(text=GetG0Text("PredMeans",S=1)))
PredMeanNames <- paste("i:",AFDSPred$Listjk[,1], ":j:", AFDSPred$Listjk[,2], sep="");
if (GenderOn == TRUE && !is.null(AFDSPred$SexVector)) {
  PredMeanNames <- paste(PredMeanNames, ":s:", AFDSPred$SexVector, sep="");
}
rownames(AllXP) = PredMeanNames;
eval(parse(text=LockGText("AllXP")))
PredMeanLength <- length(PredMeanNames);
MyBeta <- AFDSL$ADiallelObs[[1]]$Beta;
MyX = AFDSL$X;
if (!is.null(MyBeta)) {
  if (is.null(colnames(X)) || length(colnames(X)) <= 0) {
    print("My Error Warnings: Doh, colnames of X do not exist to match to MyBeta"); flush.console();
  }
  if (is.null(names(MyBeta))) {
    print("My Error Warnings: Doh, MyBeta does not have names!"); flush.console();
  }
  NeedBeta =match(colnames(X), names(MyBeta));
  if (is.null(NeedBeta) || length(NeedBeta) <= 0) {
    print("My Error Warning, for some reason, NeedBeta is length zero on match of X to MyBeta"); flush.console();
  }
  PredMeans <- MyX[, (1:length(NeedBeta))[!is.na(NeedBeta)]] %*% MyBeta[NeedBeta[!is.na(NeedBeta)]]
} else {
  PredMeans <- MyX[,1]
}

if (Verbose > 0) {
  print("  Locking PredMeanNames, PredMeanLength, PredMeans "); flush.console();
}
eval(parse(text=LockGText("PredMeanNames",S=1)));
eval(parse(text=LockGText("PredMeanLength",S=1)));
eval(parse(text=LockGText("PredMeans",S=1)));
eval(parse(text=LockGText("AFDSL",S=1)));

if (Verbose > 0) {
  print("  Getting PredSimMeanNames"); flush.console();
}
eval(parse(text=GetG0Text("PredSimMeanNames",S=1)));
PredSimMeanNames <- 1:NumSimPred; 
eval(parse(text=LockGText("PredSimMeanNames",S=1)));
if (Verbose > 0) { print("Simulate Object: Finished with AFDSL Work"); flush.console();}


if (Verbose > 0) { print("Simulate Object: Checking Out Priors"); flush.console();}

  if (!exists("PiAPrior", globalenv()) ) {
    print("PiAPrior does not exists Doh!"); flush.console();
    eval(parse(text=GetRSIText("PiAPrior"))); 
    eval(parse(text=LockGText("PiAPrior"))); 
  }

if (Verbose > 0) { print("Simulate Object: BS Stuff"); flush.console();}  
  eval(parse(text=GetG0Text("BSSaveDir")));  
  if (!exists("BSSaveDir", globalenv() ) || (length(BSSaveDir) == 1 &&
    BSSaveDir == 0) ) {
    print("BSSaveDir does not exists Doh!"); flush.console();
    eval(parse(text=GetRSIText("BSSaveDir"))); 
    eval(parse(text=LockGText("BSSaveDir"))); 
  }
  eval(parse(text=GetG0Text("BSLengthChains")));      
  if (!exists("BSLengthChains", globalenv()) || (length(BSLengthChains) == 1 &&
    BSLengthChains == 0)) {
    BSLengthChains = 1000;
    print("BSLengthChains does not exists Doh!"); flush.console();
    ##eval(parse(text=GetRSIText("BSLengthChains"))); 
    eval(parse(text=LockGText("BSLengthChains"))); 
  }
    
  eval(parse(text=GetG0Text("BSNumChains")));
  if (!exists("BSNumChains", globalenv() ) || (length(BSNumChains) == 1 &&
    BSNumChains == 0)) {
    BSNumChains = 4;
    print("BSNumChains does not exists Doh!"); flush.console();
    ##eval(parse(text=GetRSIText("BSNumChains"))); 
    eval(parse(text=LockGText("BSNumChains"))); 
  }
   



}

SimulateCompetingDiallels <- function(Verbose = 1, ModelsIn = NULL, MaxReadLength = 0,
  NoSave = FALSE) {
if (is.null(ModelsIn)) {
  if (exists("ModelsIn", globalenv()) ) {
    eval(parse(text=GetGText("ModelsIn")))
  } else {
    ModelsIn = .DefaultModelsIn;
  }
}
if (Verbose > 0) { print("Making first Simulation"); flush.console(); }

eval(parse(text=GetG0Text("nReps")));
if (nReps == 0) { nReps = 2; }
   NumReps = nReps;  NumRepetitions = nReps;
eval(parse(text=SetGText("NumReps",S=1)));
eval(parse(text=SetGText("NumRepetitions",S=1)));
             
             

if (!exists("InFixedEffects", globalenv()) ) { print("InFixedEffects Does not exist"); InFixedEffects=NULL; 
}  else {
  eval(parse(text=GetGText("InFixedEffects")));
}
if (!exists("InRandomEffects", globalenv()) ) { print("InRandomEffects Does not exist"); InRandomEffects=NULL; 
}  else {
  eval(parse(text=GetGText("InRandomEffects")));
}
if (!exists("GenderOn", globalenv()) ) { print("GenderOn Does not exist"); GenderOn=FALSE; 
}  else {
  eval(parse(text=GetGText("GenderOn")));
}
if (!exists("NumRepetitions", globalenv())  && !exists("nReps", globalenv())) {
  print("NumRepetitions Does not exist"); NumRepetitions=NULL; 
}  else if (exists("nReps", globalenv())) {
  eval(parse(text=GetG0Text("nReps", S=1)));
  NumRepetitions = nReps;
  if (!is.numeric(NumRepetitions) || NumRepetitions <= 1) {
    NumRepetitions = 1;
  }
  eval(parse(text=SetGText("NumRepetitions", S=1)))
} else {
  eval(parse(text=GetG0Text("NumRepetitions",S=1)));
  if (!is.numeric(NumRepetitions) || NumRepetitions <= 1) {
    NumRepetitions = 1;
  }
}
if (!exists("InBalance", globalenv()) ) { print("InBalance Does not exist"); InBalance=NULL; 
}  else {
  eval(parse(text=GetGText("InBalance")));
}
flush.console();

  eval(parse(text=GetG0Text("OnlyNeedTablesList", S=1)));
  if (!is.null(OnlyNeedTablesList) && is.numeric(OnlyNeedTablesList) &&
    OnlyNeedTablesList[1] == 0) {
    OnlyNeedTablesList = NULL;
  }
  if (Verbose > 0) {print("Making Simmers Now"); flush.console();}
  MySimmer = BayesDiallel:::Simmers(ModelsIn, Verbose = Verbose -1,
    OnlyNeedTablesList=OnlyNeedTablesList);
  eval(parse(text=SetGText("MySimmer",S=1)))

  if (Verbose > 0) {print("Retrieving First AFDS"); flush.console();}

  eval(parse(text=GetG0Text("AFDS", "globalenv()",S=1)));

  if (Verbose > 0 && is.null(AFDS) || (length(AFDS) == 1 && 
    is.numeric(AFDS) && AFDS == 0)) {
    print("That AFDS was null!"); flush.console();
  }

  eval(parse(text=GetG0Text("SimDfTNoise", S=1)));

  eval(parse(text=GetG0Text("Sigma", "globalenv()", S=1)));
  eval(parse(text=GetG0Text("SSigmaSq", "globalenv()", S=1)));
  if (SSigmaSq > 0) {
    Sigma = SSigmaSq;  names(Sigma) = "Sigma:1"
  } else if (Sigma > 0) {
    SSigmaSq = Sigma;  eval(parse(text=LockGText("SSigmaSq")));
    print(paste("Warning, SSigmaSq reset! to ", SSigmaSq, sep="")); flush.console();
  }
  eval(parse(text=LockGText("Sigma")));
  if (Verbose > 0) {
   print(paste("About to create AFDS, GenderOn = ", GenderOn, sep=""));
   flush.console();
  }
  AFDS <- FullDiallelSimulate(InFixedEffects = InFixedEffects,
    InRandomEffects = InRandomEffects, mRandomEffects = 20,
    dfRandomEffects = 5, tauFixedEffects = 20, YesSex = GenderOn, NumRepetitions = NumRepetitions, 
    InBalance = InBalance, dfTNoise = SimDfTNoise,  MyFullDiallelName = "AFDS: Simulator"
  );
  eval(parse(text=GetG0Text("SimIDCode", S=1)))
  eval(parse(text=GetG0Text("SimIDAllName", S=1)));
  eval(parse(text=GetG0Text("MySimUName", S=1)));
  eval(parse(text=GetG0Text("StartOnSimID", S=1)));  
  ttOn = proc.time();
  StartOnSimID = paste("T", paste(as.numeric(ttOn), collapse="t"), sep="");
  AFullSimID = paste(MySimUName, StartOnSimID, sep="");
  eval(parse(text=SetGText("StartOnSimID", S=1)))
  eval(parse(text=GetG0Text("AllDir", S=1)));
  dir.create(paste(AllDir, "//", "Simulations", sep=""), showWarnings=FALSE);
  if (NoSave != TRUE) {
  try(save(AFDS, file = paste(AllDir, "//", "Simulations//AFDS", AFullSimID, ".RData", sep="")));
  try(save(Y = AFDS$Y, Beta = AFDS$ADiallelOb$Beta, Listjk = AFDS$Listjk,
    is.female, SexVector = AFDS$SexVector,
  paste(AllDir, "//", "Simulations//SimVals", AFullSimID, ".RData", sep="")));
  }
  
  if (Verbose > 1) {
   print(paste("Setup AFDS: About to default Simulate Param ", sep=""));
   flush.console();
  }
  defaultSimulateParam(AFDS);
  AFDS$Sigma = Sigma;
  if (is.null(InRandomEffects) && is.null(InFixedEffects)) {
    if (Verbose > 1) {
     print(paste("InRandomEffects Null and InFixedEffects Null, but Gender On =  ", GenderOn, sep=""));
     flush.console();
    }
    SetupFilledSimulatedListjk(AFDS, NumRepetitions = NumRepetitions, 
      YesSex = GenderOn, InBalance = InBalance, dfTNoise = SimDfTNoise);
  }
  

  eval(parse(text=GetG0Text("Mu")));
  eval(parse(text=GetG0Text("GenderMu")));
  eval(parse(text=GetG0Text("BetaInbred")));
  eval(parse(text=GetG0Text("BetaInbredTimesGender")));
  eval(parse(text=GetG0Text("IdentifierList")));
  attach(IdentifierList);
  BetaInbredLevel = 0;
  if (BetaInbred != 0) { BetaInbredLevel = 1; }
  BetaInbredTimesSex = 0;
  if (BetaInbredTimesGender != 0) { BetaInbredTimesSex = 1; }

  if (Verbose > 0) {
    print("Setting up AFDSSimulation Model with inputs"); flush.console();
  }

  if (Verbose > 0) {
    print("Setting Beta Now"); flush.console();
  } 
  eval(parse(text=GetG0Text("SetBetaMethod")));
  if (exists("SetBetaMethod") && (SetBetaMethod > 0  || SetBetaMethod == TRUE)) {
    if (Verbose > 0) {
      print(" Getting Betajs List"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierBetaList", "globalenv()")));
    if (Verbose > 0) {
      print(" Getting IdentifierList"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierList", "globalenv()")));
    MyRDD = BayesDiallel:::.DefaultAllRandomVariables;
    MyRD2 = strsplit( MyRDD, ":");
    for (ii in 1:length(MyRD2)) { MyRDD[ii] = paste(unlist(MyRD2[[ii]]), collapse=""); }
    RText = 
     paste("SetBeta(AFDS, Mu=Mu, GenderMu = GenderMu, BetaInbred=BetaInbred, 
       BetaInbredTimesGender = BetaInbredTimesGender,
       StrainSequence = StrainSequence,
       ", paste( MyRDD, "Sequence = ", MyRDD, "Vector", collapse=", ", sep=""),"
       , Sigma = SSigmaSq );", sep="");
    if (Verbose > 2) {
      print("Now about to Set Beta with RText = ");
      print(cat(RText)); flush.console();
    }
    StrainSequence = rep(0, numj);
    if (Verbose > 2) {
      print(paste("StrainSequence = ", paste(StrainSequence, collapse=", "))); flush.console();
    }
    eval(parse(text=RText));
##    SetBeta(AFDS, Mu = Mu, GenderMu = GenderMu, BetaInbred =BetaInbred, BetaInbredTimesGender = BetaInbredTimesGender,
##      StrainSequence = ajVector, MotherSequence = MotherVector, 
##      Sigma=SSigmaSq);
  } else if (exists("SetBetaMethod") && (SetBetaMethod == FALSE || SetBetaMethod == 0)) {
    if (Verbose > 0) {
      print("Setup AFDS: Getting IDTauList Now!"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierTauList", "globalenv()")));
    if (Verbose > 0) {
      print("Setup AFDS: Getting IdentifierList Now!"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierList", "globalenv()")));
    if (Verbose > 0) {
      print("Setup AFDS: SetupSimulate Method"); flush.console();
    }
    SetupSimulateMethod(AFDS, ajModel = ajModel, MotherModel = MotherModel, 
      CrossModel = CrossModel, SexModel = SexModel, 
      BetaInbredLevel = BetaInbredLevel, 
      BetaInbredTimesSex = BetaInbredTimesSex); 
    if (Verbose > 0) {
      print("Setup AFDS: Set Tau now"); flush.console();
    }
    AFDS$SetTau(tauaj = tauaj,
      tauGenderaj = tauGenderaj, taumotherj = taumotherj, 
      tauGendermotherj = tauGendermotherj, taudominancej=taudominancej,
      tauGenderdomianncej = tauGenderdominancej, 
      tauSymCrossjk = tauSymCrossjk, tauGenderSymCrossjk = tauGenderSymCrossjk,
      tauASymCrossjkDkj = tauASymCrossjkDkj, 
      tauGenderASymCrossjkDkj = tauGenderASymCrossjkDkj,  
      tauAllCrossjk = tauAllCrossjk, tauGenderAllCrossjk = tauGenderAllCrossjk);    
  }  else {
    print("Set Beta Method did not exist, you set it yourself"); flush.console();
  }

  if (Verbose > 0) {
    print(" Now Assigning AFDS to the global environment "); flush.console();
  }
  eval(parse(text=SetGText("AFDS", "globalenv()", S=1)));
  
  
  if (Verbose > 0) {
    print("SetExampleModels now starting."); flush.console();
  }
  SetExampleModels(Verbose = Verbose -1);

  if (Verbose > 0) {
    print("Making first Large Simulation Model");
    flush.console();
  }
  eval(parse(text=GetG0Text("AllExampleModels", "globalenv()",S=1)));
  if (is.null(AllExampleModels) || length(AllExampleModels) == 1) {
    SetExampleModels();
    eval(parse(text=GetG0Text("AllExampleModels", "globalenv()")));
  }
  if (Verbose > 0) {
    print(" Now Checking out AFDSL "); flush.console();
  }  
  eval(parse(text=GetG0Text("AFDSL", "globalenv()", S=1)));
  if (Verbose > 0) {
    print("Create AFDSL: FullDiallelSimulate"); flush.console();
  }
  AFDSL <- FullDiallelSimulate(InFixedEffects = InFixedEffects,
   InRandomEffects = InRandomEffects, mRandomEffects = 20,
   dfRandomEffects = 5, tauFixedEffects = 20, YesSex = GenderOn, 
   NumRepetitions = NumRepetitions, InBalance = InBalance,  MyFullDiallelName = "AFDSL: Long variable default Simulator");
  eval(parse(text=SetGText("AFDSL", "globalenv()")));
  if (Verbose > 0) {
    print("Setting up default AFDSL parameters"); flush.console();
  }
  defaultSimulateParam(AFDSL);
  eval(parse(text=SetGText("AFDSL", "globalenv()")));
if (is.null(InRandomEffects) && is.null(InFixedEffects)) {
  SetupFilledSimulatedListjk(AFDSL, NumRepetitions = NumRepetitions, 
  YesSex = GenderOn, InBalance = InBalance);
}
  if (Verbose > 0) {
    print("Setting up default AFDSL Simulate Model from AllExample Models"); flush.console();
    print(paste("AllExampleModels[1,] = ", paste(AllExampleModels[1,], collapse=", "), sep=""));
    flush.console();
  }
  eval(parse(text=SetGText("AFDSL", "globalenv()")));
SetupSimulateMethod(AFDSL, ajModel = AllExampleModels[1,1], 
  MotherModel = AllExampleModels[1,2], CrossModel = AllExampleModels[1,3],
  SexModel = AllExampleModels[1,4], BetaInbredLevel = AllExampleModels[1,5],
  BetaInbredTimesSex = AllExampleModels[1,6], dfTNoise = SimDfTNoise,
  ParamVec = NULL);
  
FBeta = GiveAllModelsBeta(AFDSL, AllExampleModels)   
if (Verbose > 0) {
  print(paste("AFDSL: FBeta = ", paste(FBeta, collapse=", "), sep=""));
  flush.console();
}
FB = rep(0, length(FBeta));  names(FB) = FBeta;
FB[match(names(AFDS$ADiallelOb$Beta), names(FB))]  = AFDS$ADiallelOb$Beta;

FT = AFDSL$ADiallelOb$tau * 0; FTNOld = names(FT);
eval(parse(text=LockGText("AFDSL")));
  
names(FT) = paste("tau:", names(FT), sep="");
FT[match(x=names(AFDS$ADiallelOb$tau),
  ,table=FTNOld)]  = AFDS$ADiallelOb$tau;

SSSigmaSq = SSigmaSq; names(SSSigmaSq)  <- "Sigma:1";
Sigma <- SSigmaSq;  names(Sigma) = "Sigma:1";
eval(parse(text=LockGText("Sigma")));

eval(parse(text=GetG0Text("TrueParametersList")));
TrueParametersList <- c(FB, FT, Sigma); 
eval(parse(text=LockGText("TrueParametersList")));

if (Verbose > 0) {
  print("  Getting AFDSL To Set Means "); flush.console();
}
eval(parse(text=GetGText("AFDSL")));

if (!exists("InFixedEffects")) {
  eval(parse(text=GetG0Text("InFixedEffects", S=1)));
  if (length(InFixedEffects) == 1 && InFixedEffects[1] == 0) {
    InFixedEffects = NULL;
  }
}
if (!exists("InRandomEffects")) {
  eval(parse(text=GetG0Text("InRandomEffects",S=1)));
  if (length(InRandomEffects) == 1 && InRandomEffects[1] == 0) {
    InRandomEffects = NULL;
  }
} 
AFDSPred <- FullDiallelSimulate(InFixedEffects = InFixedEffects,
   InRandomEffects = InRandomEffects, mRandomEffects = 20,
   dfRandomEffects = 5, tauFixedEffects = 20, YesSex = GenderOn, 
   NumRepetitions = 1, InBalance = InBalance, MyFullDiallelName = "AFDSPred: Prediction AFDS");
  eval(parse(text=SetGText("AFDSL", "globalenv()")));
  if (Verbose > 0) {
    print("Setting up default AFDSL parameters"); flush.console();
  }
  defaultSimulateParam(AFDSPred);
  eval(parse(text=SetGText("AFDSPred", "globalenv()")));
if (is.null(InRandomEffects) && is.null(InFixedEffects)) {
  SetupFilledSimulatedListjk(AFDSPred, NumRepetitions = NumRepetitions, 
  YesSex = GenderOn, InBalance = InBalance);
}
  if (Verbose > 0) {
    print("Setting up default AFDSL Simulate Model from AllExample Models"); flush.console();
    print(paste("AllExampleModels[1,] = ", paste(AllExampleModels[1,], collapse=", "), sep=""));
    flush.console();
  }
  eval(parse(text=SetGText("AFDSPred", "globalenv()")));
SetupSimulateMethod(AFDSPred, ajModel = AllExampleModels[1,1], 
  MotherModel = AllExampleModels[1,2], CrossModel = AllExampleModels[1,3],
  SexModel = AllExampleModels[1,4], BetaInbredLevel = AllExampleModels[1,5],
  BetaInbredTimesSex = AllExampleModels[1,6], dfTNoise = SimDfTNoise,
  ParamVec = NULL);
eval(parse(text=GetG0Text("AllXP", S=1)))
AllXP = AFDSPred$X; 
  

if (Verbose > 1) {
  print("  Getting PredMeanNames  and PredMeanLength to Alter "); flush.console();
}
eval(parse(text=GetG0Text("PredMeanNames", S=1)));
eval(parse(text=GetG0Text("PredMeanLength",S=1)));
eval(parse(text=GetG0Text("PredMeans",S=1)))
PredMeanNames <- paste("i:",AFDSPred$Listjk[,1], ":j:", AFDSPred$Listjk[,2], sep="");
if (GenderOn == TRUE && !is.null(AFDSPred$SexVector)) {
  PredMeanNames <- paste(PredMeanNames, ":s:", AFDSPred$SexVector, sep="");
}
rownames(AllXP) = PredMeanNames;
eval(parse(text=LockGText("AllXP")))
PredMeanLength <- length(PredMeanNames);
MyBeta <- AFDSL$ADiallelObs[[1]]$Beta;
MyX = AFDSL$X;
if (!is.null(MyBeta)) {
  NeedBeta =match(colnames(X), names(MyBeta));
  PredMeans <- MyX[, (1:length(NeedBeta))[!is.na(NeedBeta)]] %*% MyBeta[NeedBeta[!is.na(NeedBeta)]]
} else {
  PredMeans <- MyX[,1]
}

if (Verbose > 0) {
  print("  Locking PredMeanNames, PredMeanLength, PredMeans "); flush.console();
}
eval(parse(text=LockGText("PredMeanNames",S=1)));
eval(parse(text=LockGText("PredMeanLength",S=1)));
eval(parse(text=LockGText("PredMeans",S=1)));
eval(parse(text=LockGText("AFDSL",S=1)));

if (Verbose > 0) {
  print("  Getting PredSimMeanNames"); flush.console();
}
eval(parse(text=GetG0Text("PredSimMeanNames",S=1)));
PredSimMeanNames <- 1:NumSimPred; 
eval(parse(text=LockGText("PredSimMeanNames",S=1)));
if (Verbose > 0) { print("Simulate Object: Finished with AFDSL Work"); flush.console();}


if (Verbose > 0) { print("Simulate Object: Checking Out Priors"); flush.console();}

  if (!exists("PiAPrior", globalenv()) ) {
    print("PiAPrior does not exists Doh!"); flush.console();
    eval(parse(text=GetRSIText("PiAPrior"))); 
    eval(parse(text=LockGText("PiAPrior"))); 
  }

if (Verbose > 0) { print("Simulate Object: BS Stuff"); flush.console();}  
  eval(parse(text=GetG0Text("BSSaveDir")));  
  if (!exists("BSSaveDir", globalenv() ) || (length(BSSaveDir) == 1 &&
    BSSaveDir == 0) ) {
    print("BSSaveDir does not exists Doh!"); flush.console();
    eval(parse(text=GetRSIText("BSSaveDir"))); 
    eval(parse(text=LockGText("BSSaveDir"))); 
  }
  eval(parse(text=GetG0Text("BSLengthChains")));      
  if (!exists("BSLengthChains", globalenv()) || (length(BSLengthChains) == 1 &&
    BSLengthChains == 0)) {
    BSLengthChains = 1000;
    print("BSLengthChains does not exists Doh!"); flush.console();
    ##eval(parse(text=GetRSIText("BSLengthChains"))); 
    eval(parse(text=LockGText("BSLengthChains"))); 
  }
    
  eval(parse(text=GetG0Text("BSNumChains")));
  if (!exists("BSNumChains", globalenv() ) || (length(BSNumChains) == 1 &&
    BSNumChains == 0)) {
    BSNumChains = 4;
    print("BSNumChains does not exists Doh!"); flush.console();
    ##eval(parse(text=GetRSIText("BSNumChains"))); 
    eval(parse(text=LockGText("BSNumChains"))); 
  }
   

  if (Verbose > 0) { print("  Now Setup OAs in MySimmer"); flush.console();}      
  MySimmer$SetupOAs();
  if (MaxReadLength <= 0) {
    MySimmer$WriteAndClear();
  } else {
    print(paste("MyOAs: about to MySimmer ReadMinorLength ", MaxReadLength, sep="")); flush.console();
    eval(parse(text=GetG0Text("KillLockFiles")));
    if (is.numeric(KillLockFiles) && KillLockFiles[1] == 0) {
      KillLockFiles = FALSE;
    }
    ReadASmallSimmer(MySimmer, MaxReadLength, Verbose = 5,
      KillLockFiles = KillLockFiles);
  }
  MyCurrentCount <- MySimmer$CountTables();
  MyCheckToTarget = CheckToTarget(MySimmer);
  eval(paste(text=SetGText("MyCheckToTarget", S=1)));
  if (Verbose > 2) {
    print(paste(" At end of Load in, MyCurrentCount = ", MyCurrentCount, sep="")); flush.console();
  }
  ##eval(parse(text=LockGText("MyCurrentCount")));
  
  eval(parse(text=LockGText("MySimmer")));
  eval(parse(text=LockGText("MyCurrentCount")));
  if (Verbose > 0) {
    print("We assigned, MySimmer, MyCurrentCount"); flush.console();
  }            
}


#############################################################################
##  SetExampleModels lifts information from input document
##   and then tries to discover the real diallel input parameters that
##   are availalbe at the global scope.  
##   this includes dealing with simulating new beta ("tau^2_a")
##   or working with fixed beta
##
##
##
SetExampleModels <- function(Verbose = 0) {
 if(!exists("GenderOn")) { print("SetExampleModels, GenderOn Does not exist"); flush.console(); GenderOn = FALSE;}
 if (Verbose == 0) { eval(parse(text=GetG0Text("Verbose"))); }
 PTotal = 0;
 TotalGot = 0;
 eval(parse(text=GetG0Text("AllExampleModels", S=1)));
 eval(parse(text=GetG0Text("MyiiExampleModels", S=1)));
if (GenderOn == FALSE) {
  AllExampleModels <-  GenerateModelsList(ajLevels=c(1), 
             MotherLevels=c(0,1), CrossLevels=c(0,1,2,5), 
             SexLevels = c(0), BetaInbredLevels=c(0,1,2,3), 
             BetaInbredTimesSexLevels =c(0));
} else {
  AllExampleModels <-  GenerateModelsList(ajLevels=c(1), 
             MotherLevels=c(0,1), CrossLevels=c(0,1,2,5), 
             SexLevels = c(0,1,2,3,4,5), BetaInbredLevels=c(0,1,2,3), 
             BetaInbredTimesSexLevels =c(0,1));
}

  if (Verbose > 5) {
    print("SetExampleModels:  Current AllExample Models");
    print(AllExampleModels); flush.console();
  }

  
  if (Verbose > 1) {
    print("Set Example Models: Getting AFDS");
  }
  eval(parse(text=GetGText("AFDS")));


  if (Verbose > 1) {
    print("Set Example Models: Making Example Models List");
  }
  eval(parse(text=GetG0Text("ExampleModelsList", S=1)))
ExampleModelsList <- matrix(c(AFDS$ADiallelOb$.ajModel, 
  AFDS$ADiallelOb$.MotherModel, AFDS$ADiallelOb$.CrossModel,
  AFDS$ADiallelOb$.SexModel, AFDS$ADiallelOb$.BetaInbredLevel, 
  AFDS$ADiallelOb$.BetaInbredTimesSex), 1, 6);
MyF = AllExampleModels[,1] == ExampleModelsList[1];
for (jj in 2:length(ExampleModelsList)) {                     
  MyF = MyF & ( AllExampleModels[,jj] == ExampleModelsList[jj]);
}
eval(parse(text=GetG0Text("MyiiExampleModels",S=1)));
MyiiExampleModels <- (1:length(MyF))[ MyF == TRUE];
if (length(MyiiExampleModels) == 0) {
  print("MyiiExampleModelsError, ExampleModelsList does not include me!");
  print(AllExampleModels);
  print(paste("But Real One: (", paste(ExampleModelsList, collapse=", "), ")",
    sep="")); flush.console();
}
eval(parse(text=LockGText("MyiiExampleModels",S=1)));


## The following code tries to collect a random subset of models to accelerate DIC selection
ChooseModels = unique(c(1,MyiiExampleModels, 
  sample(2:length(AllExampleModels[,1]), size=4, replace=FALSE)));
MMyiiExampleModels = 1;  
MAllExampleModels =  AllExampleModels[ChooseModels,] 
MaxModels = rep(0, length(MAllExampleModels[1,]));
for (ii in 1:length(MaxModels)) { MaxModels[ii] = max(MAllExampleModels[,ii]) }
tFlag = 0
for (jj in 1:length(MAllExampleModels[,1])) {
  if (paste(MaxModels, collapse="") == 
    paste(MAllExampleModels[jj,], collapse="")) {
    tFlag = jj;
  }
}  
 if (tFlag == 0) {MAllExampleModels = rbind(MaxModels, 
   MAllExampleModels[1,], MAllExampleModels[2:length(MAllExampleModels[,1]), ] );
   MMyiiExampleModels = 2;
 }  else if (tFlag > 1) {
     CSet = 1:length(MAllExampleModels[,1]);  
     CSet = CSet[CSet != 1 && CSet != tFlag];
     MAllExampleModels = rbind(MAllExampleModels[tFlag,], 
     MAllExampleModels[1,], 
     MAllExampleModels[CSet,])
     MMyiiExampleModels = 2;    
 }
 if (
   length(list.files("c:/Stat/DiallelTempc")) > 0 ||
   (exists("DoSmall") && DoSmall == TRUE)) {
    eval(parse(text=GetG0Text("MyiiExampleModels")));
    MyiiExampleModels <- MMyiiExampleModels;  AllExampleModels <- MAllExampleModels; UpdateVerbose <- TRUE;
    eval(parse(text=LockGText("UpdateVerbose")));
 }
 eval(parse(text=GetG0Text("LModel", S=1)))
 LModel = 1;
 eval(parse(text=LockGText("LModel",S=1)));
 eval(parse(text=LockGText("ExampleModelsList",S=1)));
 eval(parse(text=LockGText("AllExampleModels",S=1)));
 eval(parse(text=LockGText("MyiiExampleModels",S=1)));
 
 

 return();
}


RunSimulationsUntilTarget  <- function(Verbose = NULL, SepRuns = 20) {

  eval(parse(text=GetG0Text("MySimmer")));
  MyCheckToTarget = CheckToTarget(MySimmer);
  eval(parse(text=SetGText("MyCheckToTarget",S=1)));
  if (is.null(Verbose)) {
    Verbose = MySimmer$Verbose;
    if (is.null(Verbose)) {  Verbose = 0; }
  }
  while(MyCheckToTarget > 0) {
    if (Verbose > 0  && MyCheckToTarget %% SepRuns == 0) {
      print(paste("RunSimulationsUntilTarget:  We still have ", MyCheckToTarget, 
        " to go", sep="")); flush.console();
    }
    if (Verbose > 1) {
      print(paste("RunSimulationsUntilTarget:  We still have ", MyCheckToTarget, 
        " to go", sep="")); flush.console();
    }
    RunASimulation();
    eval(parse(text=GetG0Text("MyiiExampleModels")));
    if (!exists("MyiiExampleModels")) {
      print("Bleeping F, MyiiExmapleModels is not existant.")
      MyiiExampleModels = FindExampleModels();
      eval(parse(text=LockGText("MyiiExampleModels")));
    } else if (is.null(MyiiExampleModels)) {
      print("Well, MyiiExampleModels is still NULL, real peachy!"); flush.console();
    } else if (MyiiExampleModels == 0) {
      print(paste(MyCheckToTarget, " to go, but MyiiExampleModels is NULL/0", sep=""));
    }
    MyCheckToTarget = CheckToTarget(MySimmer);
    eval(parse(text=SetGText("MyCheckToTarget",S=1)));
  }
  return;
}

RunASimulation <- function(Verbose = 0, JustStart = FALSE, NoMySimmer = FALSE) {
  if (!exists("Verbose") || Verbose == 0) {
    eval(parse(text=GetG0Text("Verbose")));
  }
  eval(parse(text=GetGText("AFDS")));
  if (is.null(AFDS) || (is.numeric(AFDS) && AFDS == 0)) {
  
  }
  eval(parse(text=GetG0Text("Sigma")));
  if (is.null(Sigma) || Sigma <= 0) {
    print("RunASimulation: Error, Sigma is less than zero!");
    return(-1)
  }
  if (Verbose > 0) {
  if (!is.null(JustStart) && JustStart == TRUE) {
     print("RunASimulation: You supplied true JustStart"); flush.console();
  }  else {
    print("RunASimulation: JustStart is False"); flush.console();
  }
  }
  if (exists("SetBetaMethod", globalenv()) && (SetBetaMethod > 0  || SetBetaMethod == TRUE)) {
    eval(parse(text=AttachListText("IdentifierBetaList", "globalenv()")));
    if (Verbose > 0) {
      print(" Getting Betajs List"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierBetaList", "globalenv()")));
    if (Verbose > 0) {
      print(" Getting IdentifierList"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierList", "globalenv()")));
    MyRDD = BayesDiallel:::.DefaultAllRandomVariables;
    MyRD2 = strsplit( MyRDD, ":");
    for (ii in 1:length(MyRD2)) { MyRDD[ii] = paste(unlist(MyRD2[[ii]]), collapse=""); }
    RText = 
     paste("SetBeta(AFDS, Mu=Mu, GenderMu = GenderMu, BetaInbred=BetaInbred, 
       BetaInbredTimesGender = BetaInbredTimesGender,
       StrainSequence = StrainSequence,
       ", paste( MyRDD, "Sequence = ", MyRDD, "Vector", collapse=", ", sep=""),"
       , Sigma = SSigmaSq );", sep="");
    if (Verbose > 2) {
      print("Now about to Set Beta with RText = ");
      print(cat(RText)); flush.console();
    }
    StrainSequence = rep(0, numj);
    if (Verbose > 2) {
      print(paste("StrainSequence = ", paste(StrainSequence, collapse=", "))); flush.console();
    }
    AFDS$Sigma = Sigma;  AFDS$ADiallelOb$Sigma = Sigma;
    eval(parse(text=RText));
    AFDS$SimValues(Sigma = AFDS$ADiallelOb$Sigma, dfTNoise = AFDS$ADiallelOb$dfTNoise,
      MiceOnly= TRUE);
   } else {
    eval(parse(text=AttachListText("IdentifierTauList", "globalenv()")));
    if (Verbose > 0) {
      print("Setup AFDS: Getting IdentifierList Now!"); flush.console();
    }
    eval(parse(text=AttachListText("IdentifierList", "globalenv()")));
    if (Verbose > 0) {
      print("Setup AFDS: SetupSimulate Method"); flush.console();
    }
     SetupSimulateMethod(AFDS, ajModel = ajModel, MotherModel = MotherModel, 
      CrossModel = CrossModel, SexModel = SexModel, 
      BetaInbredLevel = BetaInbredLevel, 
      BetaInbredTimesSex = BetaInbredTimesSex, Sigma = Sigma);
    for (jti in 1:length(AFDS$ADiallelOb$tau)) {
      MyN = names(AFDS$ADiallelOb$tau)[jti];
      MyN2 = unlist(strsplit(MyN, ":"));  MyN2 = paste(MyN2, collapse="");
      MyText  = paste("AFDS$ADiallelOb$tau[jti] = tau", MyN2, ";", sep="");
      eval(parse(text=MyText));
    } 
    AFDS$SimValues(Sigma = AFDS$ADiallelOb$Sigma, dfTNoise = AFDS$ADiallelOb$dfTNoise,
      MiceOnly= FALSE, BetaOnly = TRUE);
   } 
    Beta = AFDS$ADiallelOb$Beta;
   
   eval(parse(text=GetG0Text("AFDSL")));
   eval(parse(text=GetG0Text("AllExampleModels")));  
   FBeta = GiveAllModelsBeta(AFDSL, AllExampleModels)
   eval(parse(text=LockGText("AFDSL")));
   eval(parse(text=LockGText("AllExampleModels")));   
   if (Verbose > 0) {
     print(paste("AFDSL: FBeta = ", paste(FBeta, collapse=", "), sep=""));
     flush.console();
   }
   FB = rep(0, length(FBeta));  names(FB) = FBeta;
   FB[match(names(AFDS$ADiallelOb$Beta), names(FB))]  = AFDS$ADiallelOb$Beta;


    tau = AFDS$ADiallelOb$tau;
    
    FT = AFDSL$ADiallelOb$tau * 0; FTNOld = names(FT);
    eval(parse(text=LockGText("AFDSL")));
  
    names(FT) = paste("tau:", names(FT), sep="");
    FT[match(x=names(AFDS$ADiallelOb$tau),
      ,table=FTNOld)]  = AFDS$ADiallelOb$tau;
    Sigma = AFDS$ADiallelOb$Sigma;
    names(Sigma) = "Sigma:1";
    eval(parse(text=GetG0Text("TrueParametersList", S=1)))
    TrueParametersList = c(FB, FT,
      Sigma);
    names(TrueParametersList) = c(names(FB), names(FT), names(Sigma));
    eval(parse(text=LockGText("TrueParametersList")));
  eval(parse(text=GetG0Text("AllXP", S=1)));
  eval(parse(text=GetG0Text("APredMean", S=1)));
  PredMeansVector = rep(0, dim(AllXP)[2]);
  names(PredMeansVector) = colnames(AllXP);
  MyM = match(names(TrueParametersList), names(PredMeansVector));
  if (is.null(MyM) || length(MyM) < 0) {
    print("My Error Warning: MyM NULL means PredMeansVector does not match to TrueParametersList");
    flush.console();
  }
   LTI = (1:length(MyM))[!is.na(MyM)];  MyM = MyM[!is.na(MyM)];
   PredMeansVector[MyM] = TrueParametersList[LTI];
  APredMean = as.vector(AllXP %*% PredMeansVector);
  names(APredMean) = rownames(AllXP);
  eval(parse(text=LockGText("APredMean")));
  eval(parse(text=LockGText("AllXP")));
  
  HitSimPreds = matrix(rep(APredMean, NumSimPred) +
      sqrt(AFDS$ADiallelOb$Sigma) * rnorm( length(APredMean)*NumSimPred), length(APredMean), NumSimPred);
  rownames(HitSimPreds) = PredMeanNames;
  colnames(HitSimPreds) = 1:NumSimPred;
  eval(parse(text=LockGText("HitSimPreds")));
  eval(parse(text=LockGText("APredMean")));      
  eval(parse(text=LockGText("AFDS")));
  
  if (NoMySimmer != TRUE) {
    eval(parse(text=GetG0Text("MySimmer")));
    MySimmer$RunSims(JustStart = JustStart);
  }
  if (Verbose > 0) {
  if (!is.null(JustStart) && JustStart == TRUE) {
     print("RunASimulation: JustStart was true, now just quitting"); flush.console();
  }  else {
    print("RunASimulation: JustStart is False"); flush.console();
  }
  }
  if (JustStart == TRUE) { return(); }
  if (NoMySimmer != TRUE) {
  MySimmer$WriteAndClear();
  eval(parse(text=LockGText("MySimmer")));
  }
}

SIText <- function(AText) {
  paste("  if (!exists(\"", AText, "\")) {
    print(paste(\" SetIdentifierList: Fail, could not find ", AText, "\"));
    flush.console();
    ", AText, " = 0; }
  ", sep="");
}
SimHitSimPreds <- function() {
 
  HitSimPreds = matrix(rep(APredMean, NumSimPred) +
      sqrt(Sigma) * rnorm( length(APredMean)*NumSimPred), length(APredMean), NumSimPred);
  rownames(HitSimPreds) = PredMeanNames;
  colnames(HitSimPreds) = 1:NumSimPred;
  eval(parse(text=LockGText("HitSimPreds")));
}
SetIdentifierList <- function(Verbose = 1) {
  eval(parse(text=GetG0Text("GenderOn")))
  eval(parse(text=GetG0Text("ajModel",S=1)));
  eval(parse(text=GetG0Text("MotherModel",S=1)));
  eval(parse(text=GetG0Text("CrossModel",S=1)));
  eval(parse(text=GetG0Text("SexModel",S=1)));
  eval(parse(text=GetG0Text("BetaInbredLevel",S=1)));
  eval(parse(text=GetG0Text("BetaInbredTimesSex",S=1)));
  eval(parse(text=GetG0Text("IsRandom",S=1)));
  eval(parse(text=GetG0Text("IsFixed",S=1)));
  eval(parse(text=GetG0Text("numj",S=1)));
  
  if (GenderOn == 0) { GenderMu = 0;  BetaInbredTimesSex = 0;
    eval(parse(text=SetGText("BetaInbredTimesSex", S=1)));
    eval(parse(text=SetGText("GenderMu", S=1))) }
  if (numj == 0) {
    print("Error: numj is zero, I quit!"); flush.console();
    return(-1);
  }
  eval(parse(text=GetG0Text("NumReps",S=1)));
  eval(parse(text=GetG0Text("ajModel",S=1)));
  
  eval(parse(text=GetG0Text("Mu",S=1)));
  eval(parse(text=GetG0Text("GenderMu",S=1)));
  eval(parse(text=GetG0Text("BetaInbred",S=1)));
  eval(parse(text=GetG0Text("BetaInbredTimesGender",S=1)));
  BetaInbredLevel = 0;  BetaHybridLevel =0;
  if (BetaInbred != 0) { BetaInbredLevel = 1; BetaHybridLevel = 1;}
  BetaInbredTimesSex = 0;   BetaHybridTimesSex = 0;
  if (BetaInbredTimesGender != 0) { BetaInbredTimesSex = 1; BetaHybridTimesSex = 1; }

  if (Verbose > 0) {
    print("Setting up AFDSSimulation Model with inputs"); flush.console();
  }

  if (Verbose > 0) {
    print("Setting Beta Now"); flush.console();
  } 
  eval(parse(text=GetG0Text("SetBetaMethod")));
  if (exists("SetBetaMethod", globalenv()) && (SetBetaMethod > 0  || SetBetaMethod == TRUE)) {
    if (Verbose > 0) {
      print("SetIdentifierList: Getting Betajs"); flush.console();
    }
    .DefaultAllRandomVariables = BayesDiallel:::.DefaultAllRandomVariables;
    for (ii in 1:length(BayesDiallel:::.DefaultAllRandomVariables)) {
      RDD = paste( unlist(strsplit( BayesDiallel:::.DefaultAllRandomVariables[ii], ":")), collapse="");
      if (RDD %in% c("ASymCrossjkDkj", "GenderASymCrossjkDkj")) {
        VL = (numj * (numj-1))/2;
      } else if (RDD == "SymCrossjk") {
        if (exists("dominancejVector") && max(abs(dominancejVector)) > 0) {
          VL = numj * (numj-1)/2;
        } else {VL = numj * (numj + 1) /2; }
      } else if (RDD == "GenderSymCrossjk") {
        if (exists("GenderdominancejVector") && max(abs(GenderdominancejVector)) > 0) {
          VL = numj * (numj-1)/2;
        } else {VL = numj * (numj + 1) /2; }        
      } else if (RDD == "AllSymCrossjk") {
        if (exists("dominancejVector") && max(abs(dominancejVector)) > 0) {
          VL = numj^2;
        } else {VL = numj * (numj - 1); }
      } else if (RDD == "GenderAllCrossjk") {
        if (exists("GenderdominancejVector") && max(abs(GenderdominancejVector)) > 0) {
          VL = numj^2;
        } else {VL = numj * (numj - 1); }      
      } else {
        VL = numj;
      }
      
      RText = paste("",
    " if (exists(\"", RDD,"Vector\", globalenv())) {
        ", RDD, "Vector = get(\"", RDD, "Vector\", globalenv() );
        if (length(",RDD,"Vector) <= 1 && is.na(", RDD,"Vector[1])) {
          ", RDD,"Vector = rep(0,VL)
        } else if (length(",RDD,"Vector) < VL) {
          ", RDD,"Vector = c(",RDD, "Vector, rep(0,VL -", 
          " length(", RDD, "Vector)));
        } else if (length(", RDD,"Vector) > VL) {
          ", RDD, "Vector = ", RDD, "Vector[1:VL]; 
        }
      } else {
        ", RDD, "Vector = rep(0, VL); 
      }
    ", sep="");
      eval(parse(text=RText)); 
    }
    ajModel = 0;  MotherModel = 0;  CrossModel = 0; SexModel = 0;
    if (max(abs(ajVector)) > 0) {ajModel = 1; }
    if (max(abs(motherjVector)) > 0) { MotherModel = 1; }
    if (max(abs(dominancejVector)) > 0) { CrossModel = 1; BetaInbredLevel = 3; BetaHybridLevel = 3; }
    if (max(abs(GenderdominancejVector)) > 0) { CrossModel = 1; BetaInbredTimesSex = 3; BetaHybridTimesSEx = 3; SexModel = 3;}
    if (max(abs(SymCrossjkVector)) > 0) { CrossModel = 3; }
    if (max(abs(ASymCrossjkDkjVector)) > 0) { CrossModel = 5; }
    if (max(abs(AllCrossjkVector)) > 0) { CrossModel = 8; }
    if (max(abs(GenderSymCrossjkVector)) > 0) { CrossModel = max(CrossModel,2); SexModel = max(SexModel,5); }
    if (max(abs(GenderASymCrossjkDkjVector)) > 0) { 
      CrossModel = max(CrossModel,5); SexModel = max(SexModel,5) ;}
    if (max(abs(GenderAllCrossjkVector)) > 0) { CrossModel = 8; SexModel = 6}
      MyText =  paste("IdentifierBetaList = list( 
      Mu=Mu, GenderMu=GenderMu, 
        BetaInbred=BetaInbred, BetaInbredTimesGender=BetaInbredTimesGender,", sep="");
    for (ii in 1:length(BayesDiallel:::.DefaultAllRandomVariables)) {
      RDD = paste( unlist(strsplit( BayesDiallel:::.DefaultAllRandomVariables[ii], ":")), collapse="");
      if (ii > 1) {  MyText = paste(MyText, ", ", sep="");}
      MyText = paste(MyText, "
      ", RDD, "Vector = ", RDD, "Vector", sep="");
    }
    MyText = paste(MyText, ");", sep="");
    eval(parse(text=MyText));
    if (Verbose > 2) {
      print("Now about to Set Beta with RText = ");
      print(cat(RText)); flush.console();
    }
    StrainSequence = rep(0, numj);
    if (Verbose > 2) {
      print(paste("StrainSequence = ", paste(StrainSequence, collapse=", "))); flush.console();
    }
    eval(parse(text=RText));
    eval(parse(text=LockGText("IdentifierBetaList")));
##    SetBeta(AFDS, Mu = Mu, GenderMu = GenderMu, BetaInbred =BetaInbred, BetaInbredTimesGender = BetaInbredTimesGender,
##      StrainSequence = ajVector, MotherSequence = MotherVector, 
##      Sigma=SSigmaSq);
  } else if (exists("SetBetaMethod", globalenv()) && (SetBetaMethod == FALSE || SetBetaMethod == 0)) {
    if (Verbose > 0) {
      print("Set IdentifierList: Setting Tau Now!"); flush.console();
    }
    ajModel = 0;  MotherModel = 0;  CrossModel = 0; SexModel = 0;
    AllRandom = BayesDiallel:::.DefaultAllRandomVariables;
    if (Verbose > 0) {
      print(" Getting all of the tauajs."); flush.console();
    }
    for (ii in 1:length(AllRandom)) {
      RDD = paste( unlist(strsplit( AllRandom[ii], ":")), sep="");
      RText = paste(
    " if (exists(\"tau", RDD,"\", globalenv())) {
        tau", RDD, " = get(\"tau", RDD, "\", globalenv() );
      } else {
        tau", RDD, " = 0; 
      }
    ", sep="");
      eval(parse(text=RText)); 
    }
    if (tauaj > 0) {ajModel = 1; }
    if (taumotherj > 0) { MotherModel = 1; }
    if (taudominancej > 0) { CrossModel = 1; BetaInbredLevel = 3; BetaHybridLevel = 3; }
    if (tauGenderdominancej > 0) { CrossModel = 1; BetaInbredTimesSex = 3; BetaHybridTimesSex = 3;}
    if (tauSymCrossjk > 0) { CrossModel = 2; }
    if (tauASymCrossjkDkj > 0) { CrossModel = 5; }
    if (tauAllCrossjk > 0) { CrossModel = 8; }
    if (tauGenderSymCrossjk > 0) { CrossModel = 2; SexModel = 5 }
    if (tauGenderASymCrossjkDkj > 0) { CrossModel = 5; SexModel = 5}
    if (tauGenderAllCrossjk > 0) { CrossModel = 8; SexModel = 6}
    MyText =  paste("IdentifierTauList = list( Mu=Mu, GenderMu=GenderMu, 
      BetaInbred=BetaInbred, BetaInbredTimesGender=BetaInbredTimesGender,
      BetaHybrid=BetaInbred, BetaHybridTimesGender=BetaInbredTimesGender, ", sep="");
    for (ii in 1:length(BayesDiallel:::.DefaultAllRandomVariables)) {
      RDD = paste( unlist(strsplit( BayesDiallel:::.DefaultAllRandomVariables[ii], ":")), collapse="");
      if (ii > 1) { MyText = paste(MyText, ", ", sep="");}
      MyText = paste(MyText,   "
       tau", RDD, " = tau", RDD, sep="");
    }
    MyText = paste(MyText, ");", sep="");
    eval(parse(text=MyText));
    eval(parse(text=LockGText("IdentifierTauList")));
  }  else {
    print("Set Beta Method did not exist, you set it yourself"); flush.console();
  }
  
          
  IdentifierList = list(ajModel=ajModel, MotherModel=MotherModel, 
  CrossModel = CrossModel, SexModel = SexModel, 
  BetaInbredLevel = BetaInbredLevel, BetaInbredTimesSex = BetaInbredTimesSex,
  BetaHybridLevel = BetaHybridLevel, BetaHybridTimesSex = BetaHybridTimesSex,
  IsRandom=IsRandom, IsFixed = IsFixed, numj = numj, NumReps = NumReps)
  eval(parse(text=LockGText("IdentifierList"))); 
}


AttachListText <- function(AList, envir = "globalenv()") {
  eval(parse(text=GetGText(AList, envir)));
  GetNames = paste("ListNames = names(", AList, ");", sep="");
  eval(parse(text=GetNames));
  MyAllText = paste(GetGText(AList, envir), " 
  ", sep="");
  for (ii in 1:length(ListNames)) {
   MyText = paste( ListNames[ii], " = ", AList, "$", ListNames[ii], sep="");
   MyAllText = paste(MyAllText, "
   ", MyText, sep="");
  }
  return(MyAllText);
}

LMin <- function(AList) {
  if (!is.list(AList) && is.numeric(AList)) {
    return(min(AList));
  }
  if (is.list(AList)) {
    RTT = rep(0, length(AList));
    for (ii in 1:length(AList)) {
      RTT = min(AList[[ii]]);
    }
    return(min(RTT));
  }
  return(0);
}

MakeOAs <- function(GiveTargetGroups = NULL) {
  TrueParameterVec = MySimmer$SimL[[1]]$MyOA$TrueParamTable$ReadTable[1,];
  eval(parse(text=SetGText("TrueParameterVec", S=1)));
  MakeGriffingOAs();
  MakeDiallelOAs();
  
  MedianSigLevel = .01; MIPSigLevel=.2;
  SubSetIters = NULL; HitSimPreds = NULL;
  if (is.null(GiveTargetGroups)) {
    eval(parse(text=GetG0Text("GiveTargetGroups", S=1)));
    if (is.numeric(GiveTargetGroups) && !is.null(GiveTargetGroups) &&
      length(GiveTargetGroups) == 1 && GiveTargetGroups[1] == 0) {
      GiveTargetGroups = NULL; 
    }  
  }
  if (is.null(GiveTargetGroups)) {
    GiveTargetGroups = "";
    RDD = (1:length(TrueParameterVec))[substr(names(TrueParameterVec),1,nchar("tau")) == "tau"];
    GiveTargetGroups = unique(substr(names(TrueParameterVec)[RDD], 5, nchar(names(TrueParameterVec)[RDD])));
  }
  eval(parse(text=SetGText("MedianSigLevel", S=1)));
  eval(parse(text=SetGText("MIPSigLevel", S=1)));
  eval(parse(text=SetGText("SubSetIters", S=1)));     
  eval(parse(text=SetGText("HitSimPreds", S=1)));
  eval(parse(text=SetGText("GiveTargetGroups", S=1)));
   
}
MakeGriffingOAs <- function() {
  eval(parse(text=GetG0Text("GriffingOAs", S=1)));
  eval(parse(text=GetG0Text("TargetGTable",S=1)));
  eval(parse(text=GetG0Text("TargetGProb",S=1))); 
  GriffingOAs = list();   Onii = 0;
  TargetGTable = c();
  TargetGProb = c();
  GriffingTypes = c();
  GriffingMethodNames = c();
  GriffingModelNames = c();
  GriffingModelSubNames = c();
  for (ii in 1:length(MySimmer$SimL)) {
    nSimL = MySimmer$SimL[[ii]]$Type;
    if (substr(nSimL,1,nchar("Griff")) == "Griff"  ||
      nSimL == "Diallelhglm" || nSimL == "DiallelHglm") {
      Onii = Onii + 1;
      GriffingOAs[[Onii]] = MySimmer$SimL[[ii]]$MyOA;
      TargetGTable = c(TargetGTable, MySimmer$SimL[[ii]]$PreferMeanMedian)
      TargetGProb = c(TargetGProb, MySimmer$SimL[[ii]]$PreferSmpValMIPVal)
      GriffingTypes = c(GriffingTypes, MySimmer$SimL[[ii]]$Type);
      GriffingMethodNames = c(GriffingMethodNames, MySimmer$SimL[[ii]]$MyOA$MethodName);
      GriffingModelNames = c(GriffingModelNames, MySimmer$SimL[[ii]]$MyOA$ModelName);
      GriffingModelSubNames = c(GriffingModelSubNames, MySimmer$SimL[[ii]]$MyOA$ModelSubName);      
    }
  }

  eval(parse(text=SetGText("GriffingOAs", S=1)));
  eval(parse(text=SetGText("TargetGTable",S=1)));
  eval(parse(text=SetGText("TargetGProb",S=1)));
  eval(parse(text=SetGText("GriffingTypes", S=1)))
  eval(parse(text=SetGText("GriffingModelNames", S=1)))
  eval(parse(text=SetGText("GriffingMethodNames", S=1)))
  eval(parse(text=SetGText("GriffingModelSubNames", S=1)))
  
  eval(parse(text=GetG0Text("GriffingOAs1", S=1)));
  eval(parse(text=GetG0Text("TargetGTable1",S=1)));
  eval(parse(text=GetG0Text("TargetGProb1",S=1))); 
  GriffingOAs1 = list();   Onii = 0;
  TargetGTable1 = c();
  TargetGProb1 = c();
  GriffingTypes1 = c();
  GriffingMethodNames1 = c();
  GriffingModelNames1 = c();
  GriffingModelSubNames1 = c();
  for (ii in 1:length(MySimmer$SimL)) {
    nSimL = MySimmer$SimL[[ii]]$Type;
    if (substr(nSimL,1,nchar("Griff")) == "Griff"
      || nSimL == "Diallelhglm") {
      Onii = Onii + 1;
      GriffingOAs1[[Onii]] = MySimmer$SimL[[ii]]$MyOA;
      TargetGTable1 = c(TargetGTable1, MySimmer$SimL[[ii]]$PreferMeanMedian)
      TargetGProb1 = c(TargetGProb1, MySimmer$SimL[[ii]]$PreferSmpValMIPVal)
      GriffingTypes1 = c(GriffingTypes1, MySimmer$SimL[[ii]]$Type);
      GriffingMethodNames1 = c(GriffingMethodNames1, MySimmer$SimL[[ii]]$MyOA$MethodName);
      GriffingModelNames1 = c(GriffingModelNames1, MySimmer$SimL[[ii]]$MyOA$ModelName);
      GriffingModelSubNames1 = c(GriffingModelSubNames1, MySimmer$SimL[[ii]]$MyOA$ModelSubName);      
    }
  }

  eval(parse(text=SetGText("GriffingOAs1", S=1)));
  eval(parse(text=SetGText("TargetGTable1",S=1)));
  eval(parse(text=SetGText("TargetGProb1",S=1)));
  eval(parse(text=SetGText("GriffingTypes1", S=1)))
  eval(parse(text=SetGText("GriffingModelNames1", S=1)))
  eval(parse(text=SetGText("GriffingMethodNames1", S=1)))
  eval(parse(text=SetGText("GriffingModelSubNames1", S=1)))
  
   eval(parse(text=GetG0Text("GriffingOAs2", S=1)));
  eval(parse(text=GetG0Text("TargetGTable2",S=1)));
  eval(parse(text=GetG0Text("TargetGProb2",S=1))); 
  GriffingOAs2 = list();   Onii = 0;
  TargetGTable2 = c();
  TargetGProb2 = c();
  GriffingTypes2 = c();
  GriffingMethodNames2 = c();
  GriffingModelNames2 = c();
  GriffingModelSubNames2 = c();

  eval(parse(text=SetGText("GriffingOAs2", S=1)));
  eval(parse(text=SetGText("TargetGTable2",S=1)));
  eval(parse(text=SetGText("TargetGProb2",S=1)));
  eval(parse(text=SetGText("GriffingTypes2", S=1)))
  eval(parse(text=SetGText("GriffingModelNames2", S=1)))
  eval(parse(text=SetGText("GriffingMethodNames2", S=1)))
  eval(parse(text=SetGText("GriffingModelSubNames2", S=1)))
  
}
MakeDiallelOAs <- function() {
  eval(parse(text=GetG0Text("TargetRDTable", S=1)));
  eval(parse(text=GetG0Text("TargetRDProb",S=1)));
  eval(parse(text=GetG0Text("BayesDiallelOAs",S=1))); 
  BayesDiallelOAs = list();   Onii = 0;
  TargetRDTable = c();
  TargetRDProb = c();
  RDTypes= c();
  RDMethodNames=c();
  RDModelNames = c();
  RDModelSubNames =c();
  for (ii in 1:length(MySimmer$SimL)) {
    nSimL = MySimmer$SimL[[ii]]$Type;
    if (substr(nSimL,1,nchar("Diallel")) == "Diallel" &&
      nSimL != "Diallelhglm") {
      Onii = Onii + 1;
      if (!is.null(MySimmer$SimL[[ii]]$MyOAMX$MeanVals$ReadTable)) {
        BayesDiallelOAs[[Onii]] = MySimmer$SimL[[ii]]$MyOAMX;
      } else {
        BayesDiallelOAs[[Onii]] = MySimmer$SimL[[ii]]$MyOA;
      }
      TargetRDTable = c(TargetRDTable, MySimmer$SimL[[ii]]$PreferMeanMedian)
      TargetRDProb = c(TargetRDProb, MySimmer$SimL[[ii]]$PreferSmpValMIPVal)
      AType = MySimmer$SimL[[ii]]$Type
      if (substr(AType, nchar(AType)-nchar("Outlier")+1, nchar(AType)) == "Outlier") {
        AType = paste(AType, " d.f.=", MySimmer$SimL[[ii]]$dfTNoise, sep="");
      }
      RDTypes = c(RDTypes, AType);
      RDMethodNames = c(RDMethodNames, MySimmer$SimL[[ii]]$MyOA$MethodName);
      RDModelNames = c(RDModelNames, MySimmer$SimL[[ii]]$MyOA$ModelName);
      RDModelSubNames = c(RDModelSubNames, MySimmer$SimL[[ii]]$MyOA$ModelSubName);
      
    }
  }

  eval(parse(text=SetGText("TargetRDTable",S=1)));
  eval(parse(text=SetGText("TargetRDProb",S=1)));
  eval(parse(text=SetGText("BayesDiallelOAs",S=1)));
  eval(parse(text=SetGText("RDTypes", S=1)))
  eval(parse(text=SetGText("RDModelNames", S=1)))
  eval(parse(text=SetGText("RDMethodNames", S=1)))
  eval(parse(text=SetGText("RDModelSubNames", S=1)))  

}


SetCommonExampleModels <- function() {
   PTotal = 0;
  TotalGot = 0;
  eval(parse(text=GetG0Text("GenderOn")));
  if (is.null(GenderOn)) { GenderOn = FALSE; }
if (GenderOn == FALSE) {
AllExampleModels =  GenerateModelsList(ajLevels=c(1), 
             MotherLevels=c(0,1), CrossLevels=c(0,1,2,5), 
             SexLevels = c(0), BetaInbredLevels=c(0,1,2,3), 
             BetaInbredTimesSexLevels =c(0));
} else {
AllExampleModels =  GenerateModelsList(ajLevels=c(1), 
             MotherLevels=c(0,1), CrossLevels=c(0,1,2,5), 
             SexLevels = c(0,1,2,3,4,5), BetaInbredLevels=c(0,1,2,3), 
             BetaInbredTimesSexLevels =c(0,1,2,3));
}

 if (!exists("ajModel")) { ajModel = 1;}
 if (!exists("MotherModel")) { MotherModel = 0;}
 if (!exists("CrossModel")) {CrossModel = 0;}
 if (!exists("SexModel"))  {if ((!is.numeric(GenderOn) && GenderOn == TRUE) 
   || GenderOn == 1) {
    SexModel = 1;
   } else { SexModel = 0; 
   }}
 if (!exists("BetaInbredLevel")) { BetaInbredLevel = 0;}
 if (!exists("BetaInbredTimesSex")) { BetaInbredTimesSex = 0; }
ExampleModelsList = matrix(c(ajModel, MotherModel, CrossModel,
      SexModel, BetaInbredLevel, BetaInbredTimesSex), 1, 6);
MyF = AllExampleModels[,1] == ExampleModelsList[1];
for (jj in 2:length(ExampleModelsList)) {                     
  MyF = MyF & ( AllExampleModels[,jj] == ExampleModelsList[jj]);
}
MyiiExampleModels = (1:length(MyF))[ MyF == TRUE];

ChooseModels = unique(c(MyiiExampleModels, 
  sample(1:length(AllExampleModels[,1]), size=4, replace=FALSE)));
MMyiiExampleModels = 1;  
MAllExampleModels =  AllExampleModels[ChooseModels,] 
MaxModels = rep(0, length(MAllExampleModels[1,]));
for (ii in 1:length(MaxModels)) { MaxModels[ii] = max(MAllExampleModels[,ii]) }
tFlag = 0
for (jj in 1:length(MAllExampleModels[,1])) {
  if (paste(MaxModels, collapse="") == 
    paste(MAllExampleModels[jj,], collapse="")) {
    tFlag = jj;
  }
}  
 if (tFlag == 0) {MAllExampleModels = rbind(MaxModels, 
   MAllExampleModels[1,], MAllExampleModels[2:length(MAllExampleModels[,1]), ] );
   MMyiiExampleModels = 2;
 }  else if (tFlag > 1) {
     CSet = 1:length(MAllExampleModels[,1]);  
     CSet = CSet[CSet != 1 && CSet != tFlag];
     MAllExampleModels = rbind(MAllExampleModels[tFlag,], 
     MAllExampleModels[1,], 
     MAllExampleModels[CSet,])
     MMyiiExampleModels = 2;    
 }
if (
  length(list.files("c:/Stat/DiallelTempc")) > 0) {
   MyiiExampleModels = MMyiiExampleModels;  AllExampleModels = MAllExampleModels; UpdateVerbose = TRUE;
}
eval(parse(text=LockGText("MyiiExampleModels",S=1)));
eval(parse(text=LockGText("AllExampleModels",S=1)));  
    
    
}


## Note AxisTitle causes the bottom axis of plots to be printed in Valdar notation
##   else, the plots are printed with vector names in bottom
PlotAllTauPlots <- function(subfraction = .5, DoLog = FALSE,
  DoTauLog = FALSE, DoBayesFactorLog = TRUE, DoMIPLog = FALSE,
  TauVOrdered = NULL,SaveDir = NULL, FileName = NULL, ExperimentName = "",
  RealVec=RealVec, DoAbs = FALSE, AxisTitle = TRUE) {
  if (DoLog == TRUE) {
    DoTauLog = TRUE; DoBayesFactorLog = TRUE;  DoMIPLog = TRUE;
  }
  NTPlots = 0;
  PlotMeLargeList = c();
  PlotMeLargeOutlierList = c();
  PlotMeSpikeList = c();
  PlotMeSpikeOutlierList = c();
  for (ii in 1:length(MySimmer$SimL)) {
    if (MySimmer$SimL[[ii]]$Type == "DiallelLarge") {
      NTPlots = NTPlots + 1;   
      PlotMeLargeList=c(PlotMeLargeList,ii)
    } else if (MySimmer$SimL[[ii]]$Type == "DiallelLargeOutlier") {
      NTPlots = NTPlots + 1;
      PlotMeLargeOutlierList=c(PlotMeLargeOutlierList,ii)
    } else if (MySimmer$SimL[[ii]]$Type == "DiallelSpike") {
      NTPlots = NTPlots + 3;
      PlotMeSpikeList=c(PlotMeSpikeList,ii)
    } else if (MySimmer$SimL[[ii]]$Type == "DiallelSpikeOutlier") {
      NTPlots = NTPlots + 3;
      PlotMeSpikeOutlierList=c(PlotMeSpikeOutlierList,ii)
    }
  }
  try(eval(parse(text=GetG0Text("IdentifierBetaList", "globalenv()"))), silent=TRUE);
  try(eval(parse(text=GetG0Text("IdentifierTauList", "globalenv()"))), silent=TRUE);
  if (!exists("TauVOrdered")  || is.null(TauVOrdered)) {
    if (exists("IdentifierBetaList") && !is.null(IdentifierBetaList) && is.list(IdentifierBetaList) && !(is.numeric(IdentifierBetaList) && length(IdentifierBetaList) == 1 &&
    IdentifierBetaList[1] == 0)) {
      GrGroups = names(AFDSL$ADiallelOb$tau);
      KGrGroups = EatFingColons(GrGroups);
      NIdentifierBetaList = names(IdentifierBetaList);
        LTBetaList = rep(0, length(IdentifierBetaList));
        for (ii in 1:length(NIdentifierBetaList)) {
          if (substr(NIdentifierBetaList[ii], nchar(NIdentifierBetaList[ii]) - nchar("vector")+1, nchar(NIdentifierBetaList[ii])) == "Vector") {
            NIdentifierBetaList[ii] = substr(NIdentifierBetaList[ii], 1, nchar(NIdentifierBetaList[ii]) - nchar("Vector"));         
          }    
        }
        for (ii in 1:length(LTBetaList)) { LTBetaList[ii] = sd(IdentifierBetaList[[ii]]);}
        names(LTBetaList) = NIdentifierBetaList;
     KeepLTBetaList = LTBetaList[ names(LTBetaList) %in% KGrGroups ]
       
     TauVOrdered = names(sort(KeepLTBetaList, decreasing=TRUE));
  } else if (!is.null(IdentifierTauList)  && is.list(IdentifierTauList) && !(is.numeric(IdentifierTauList) && length(IdentifierTauList) == 1 &&
    IdentifierTauList[1] == 0)) {
     PUn = unlist(IdentifierTauList);
     PNeed = PUn[substr(names(PUn), 1, nchar("tau")) == "tau"];
     RankPNeed =sort(PNeed, decreasing=TRUE, index=TRUE)
     TauVOrdered = names(PNeed[RankPNeed$ix]);
     TauVOrdered = substr(TauVOrdered,nchar("tau")+1, nchar(TauVOrdered));
  
  }}
  
  ITT = (1:length(MySimmer$SimL[[1]]$MyOA$MeanVals$ReadTable[,1]));
  if (length(subfraction) > 1) {
    ITT = ITT[ITT %in% subfraction];
  } else if (subfraction > 1) {
    ITT = sort(sample(ITT, size = subfraction,
      replace=FALSE));
  } else {
     ITT = sort(sample(ITT, size = round(length(ITT) * subfraction),
      replace=FALSE));
  }
  subfraction=ITT;
  if (!is.null(FileName)) {
    if (exists("SaveDir")  && !is.null(SaveDir) && SaveDir != "") {
      FileName = paste(SaveDir, "//", FileName, sep="");
    }
    pdf(file = FileName, width=6, height=30, 
       #1.5 * length(TauVOrdered), 3.5 * NTPlots,
       title=ExperimentName);
  }
  par(mfrow=c(NTPlots, 1));
  if (length(PlotMeLargeList)>=1){
  for (ii in 1:length(PlotMeLargeList)) {
   PlotSDV(MySimmer$SimL[[PlotMeLargeList[ii]]]$MyOAMX, subfraction=subfraction,DoLog = DoTauLog,
     TauVOrdered = TauVOrdered, mainadd = " Large Total Diallel ", RealVec=RealVec,DoAbs=DoAbs, AxisTitle = AxisTitle);
  }}
  if (length(PlotMeLargeOutlierList)>=1) {
   for (ii in 1:length(PlotMeLargeOutlierList)) {
   PlotSDV(MySimmer$SimL[[PlotMeLargeOutlierList[ii]]]$MyOAMX, subfraction=subfraction,DoLog = DoTauLog,
     TauVOrdered = TauVOrdered, mainadd = paste(" Large Diallel Outlier, df = ",
       MySimmer$SimL[[PlotMeLargeOutlierList[ii]]]$dfTNoise, sep=""), RealVec=RealVec, DoAbs=DoAbs,  AxisTitle = AxisTitle);
  }}
  if (length(PlotMeSpikeList)>=1) {
  for (ii in 1:length(PlotMeSpikeList)) {
   PlotSDV(MySimmer$SimL[[PlotMeSpikeList[ii]]]$MyOAMX, subfraction=subfraction,DoLog = DoTauLog,
     TauVOrdered = TauVOrdered, mainadd = paste(" SpikeSelection ", sep=""), RealVec=RealVec, DoAbs=DoAbs,
     DoMedian = TRUE,  AxisTitle = AxisTitle);
   PlotMIPTau(MySimmer$SimL[[PlotMeSpikeList[ii]]]$MyOAMX, subfraction=subfraction,DoLog = DoMIPLog,
     ProbVOrdered = TauVOrdered, mainadd = paste(" Spike Selection ", sep=""), AxisTitle = AxisTitle);
  PlotBayesFactorTau(MySimmer$SimL[[PlotMeSpikeList[ii]]]$MyOA, subfraction=subfraction,DoLog = DoBayesFactorLog,
     ProbVOrdered = TauVOrdered, mainadd = paste(" Spike Selection ", sep=""), AxisTitle = AxisTitle);
  }}
  if (length(PlotMeSpikeOutlierList)>=1) {
  for (ii in 1:length(PlotMeSpikeOutlierList)) {
    PlotSDV(MySimmer$SimL[[PlotMeLargeOutlierList[ii]]]$MyOAMX, subfraction=subfraction,DoLog = DoTauLog,
     TauVOrdered = TauVOrdered, mainadd = paste(" Spike Selection Outlier, df = ",
       MySimmer$SimL[[PlotMeLargeOutlierList[ii]]]$dfTNoise, sep=""), RealVec=RealVec, DoAbs=DoAbs,DoMedian = TRUE,
        AxisTitle = AxisTitle);
   PlotMIPTau(MySimmer$SimL[[PlotMeSpikeOutlierList[ii]]]$MyOAMX, subfraction=subfraction,DoLog = DoMIPLog,
     ProbVOrdered = TauVOrdered, mainadd = paste(" Spike Selection Outlier, df = ",
       MySimmer$SimL[[PlotMeSpikeOutlierList[ii]]]$dfTNoise, sep=""), AxisTitle = AxisTitle);
  PlotBayesFactorTau(MySimmer$SimL[[PlotMeSpikeOutlierList[ii]]]$MyOA, subfraction=subfraction,DoLog = DoBayesFactorLog,
     ProbVOrdered = TauVOrdered, mainadd = paste(" Spike Selection Outlier, df = ",
       MySimmer$SimL[[PlotMeSpikeOutlierList[ii]]]$dfTNoise, sep=""), AxisTitle = AxisTitle);     
  } }
  
  if (!is.null(FileName)) {
    dev.off();
  }
  return;
}