\name{FullDiallelAnalyze}
\alias{FullDiallelAnalyze}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Create FullDiallelAnalyze Object }
\description{
  Create "FullDiallel" object specifically of Analyze type
}
\usage{
FullDiallelAnalyze(numj=defaultnumj,  Y = NULL, InListjk = NULL, InSexVector=NULL,
  InFixedEffects = NULL, nameFixedEffects = NULL,
  InRandomEffects = NULL, nameRandomEffects = NULL,
  InRandomPrintEffects=NULL, dfTNoise = NULL,
  Indf = NULL, Inm = NULL, IntauFixed=NULL, 
  Indftau = NULL,Inmtau = NULL,ListUnknownSex=NULL, 
  ProbFemaleUnknownSex, NoChainsUnknownSex=NULL,...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Y}{Dependendent Vector}
  \item{numj}{ Number of total Strains in Diallel}
  \item{Indf}{ A "RConstantsList", object representing prior inverse gamma degrees of freedom for parameters. 
    default NULL sets all values at .5}
  \item{Inm}{A "RConstantsList",object representing prior inverse gamma scaling for parameters. 
    default NULL sets all values at .5 }
  \item{dfTNoise}{If dfTNoise >0, then a outlier procedure based upon t-distributed noise is used}
  \item{InSexVector}{A vector declaring 0 if mouse is female, 1 if male}
  \item{InListjk}{A two column list, first column, strain of mother, second column, strain of father}
  \item{IntauFixed}{In Starting parameters for the fixed coefficients}
  \item{verbose}{ Decision to print actions to console }
  \item{Indftau}{Hierarchical prior information}
  \item{Inmtau}{Hierarchical prior information}
  \item{ListUnknownSex}{See method \code{\link{SetupUnknownSex}} A list of specimen numbers for which sex is unknown. 
    An alias name is \code{ListUnknownGender}}
  \item{ProbFemaleUnknownSex}{See method \code{\link{SetupUnknownSex}} A vector of prior probabilities that each
     specimen with unknown gender is male or female.  An alias name is \code{ProbUnknownGender}}
  \item{NoChainsUnknownSex}{ A flag on whether to save \code{\link[coda]{mcmc}} chains for the sex imputation. 
    An alias name is \code{NoChainsUnknownGender}}
  \item{MissingYIndices}{Indices of Y that can be considered Censored or missing.  If any Y are NA, then this
    will be automatically generated.  Alternative is to use function SetupUnknownY}
  \item{LowCensorBound}{Somewhat of a misnomer.  If Data that is "NA" or missing in MissingYIters is considered
    "Censored", in that it is generated NA if the data is above the LowCensorBound, then Imputed Missing Y
    will only be imputed as values GREATER than LowCensorBound.  If LowCensorBound is NULL, there is no lower
    boundary.}
  \item{UpCensorBound}{Somewhat of a misnomer.  If Data that is "NA" or missing in MissingYIters is considered
    "Censored", in that it is generated NA if the data is below the UpCensorBound, then Imputed Missing Y
    will only be imputed as values LESS than UpCensorBound.  If UpCensorBound is NULL, there is no upper boundary.}
  \item{NoChainsImputeY}{Set to TRUE if one does not want to collect coda values for imputed Y.  Imputed Y 
    values will be sored in \code{\link{DiallelOb}} piece "ImputedYChains"}
  \item{DoGelman}{Logical Flag whether to use Gelman-Rubin analysis to judge convergence/mixing of chains and
     whether to double cain length and run again.  For problematic datasets, the BayesDiallel procedure
     may decide that many chain results are needed.  By Setting DoGelman = FALSE, the algorithm will
     stop after the initial first chains are filled in.}
}
\details{
  All Analyses will use "FullDiallelAnalyze", an inherited class of Full Diallel
}
\value{
    Object  
     \item{FullDiallel Object}{An S3 Class designed to test multiple diallel models on the same dataset}
     
    
    This \code{FullDiallelAnalyze} R.oo Object contains members:
    \item{AllDiallelObs}{List of \code{\link{DiallelOb}}s }
    \item{On}{Id number of Diallel Ob we are on}
    \item{ListFunctions}{List of Functions available to this FullDiallelAnalyze Object}
    \item{ListElements}{List of Elements available to this FullDiallelAnalyze Object}
    \item{cent.chains}{For DiallelObject "On", Output Chains, with shrink towards group mean, for official analysis.  Runs
       "AutoMFFunction" on CodaChains, to create this if not created yet} 
    \item{raw.chains}{For DiallelObject "On", Original Output chains from MCMC sampler.  Setup by SetupChains}
    \item{Y}{The Phenotype Vector}
    \item{SexVector}{The Sex Vector}
    \item{Listjk}{Two columns listing mother strain j (first column) and father strain k (second column)}
    \item{X}{A all inclusive X matrix listing covariates set based upon SexVector,Listjk,RandomEffects, and FixedEffects}
    \item{RandomEffects}{Covariate List of Random Effects}
    \item{RandomEffectsGroups}{Lists the groups that each Random Effects set goes into if more than one}
    \item{nameFixedEffects}{Name to give columns of Fixed Effects to be stored for column name}
    \item{nameRandomEffects}{Name to be given to Random Effects Groups}
    \item{burnin}{Integer > 0 to be used as default burnin time for chains}
    \item{thin}{Integer >= 1 to be used as thinning interval for chains}
    \item{dfTNoise}{If < 0, no t-distributed noise is used.  If > 0, this t-noise degrees of freedom is applied to all objects}
    \item{PosetiorPredictionsMeanSummary}{Summary of predictions for mean of squares of On DiallelOb}
    \item{PosteriorPredictionsErrorSummary}{Summary of predictions for mean of squares + error draws of On DiallelOb}
    \item{PosetiorPredictionsMeanChains}{Coda Chains of predictions for mean of squares of On DiallelOb}
    \item{PosteriorPredictionsErrorChains}{Coda Chains of predictions for mean of squares + error draws of On DiallelOb}
    \item{ListUnknownSex}{A vector listing which specimens have unknown Gender.  
      An alias is \code{ListUnknownGender}}
    \item{ProbFemaleUnknownSex}{Probability vector listing priors for unknown Gender of unknown gendered specimens.
      An alias is \code{ProbUnknownGender}}
    \item{ImputeGenderSex}{Chains of DiallelOb On that show Imputed Sex.  An alias is \code{ImputeGenderChains}}
    \item{ImputedSex}{Current Imputed Sex, an alias is \code{ImputedGender}}
    \item{NoChainsUnknownGender}{Indicator that one does not want to record Coda chains of Imputed Sex}
    \item{LogTransformedFlag}{Indicator whether Y phenotype data was Log transformed}
    \item{SqrtTransformedFlag}{Indicator whether Y phenotype data was Sqrt transformed}

    
    This \code{FullDiallelAnalyze} R.oo Object has functions (methods) that can be used
    \item{\code{\link{SetupAnalysisMethods}}()}{Setup the "AllDiallelObs" member includeing all \code{\link{DiallelOb}}s.  
    A matrix ModelsList must be supplied which encodes the models one would like to setup.}
    \item{\code{\link{SetupChains}}()}{Setup the Coda chains for analysis}
    \item{\code{\link{RunChains}}()}{Run the analysis on all \code{\link{DiallelOb}}s.}
    \item{\code{\link{SetupUnknownGender}}()}{If Gender is missing (NA) for some specimens, this sets up imputation process}
    \item{\code{\link{MysteryGender}}()}{Helper function to SetupUnknownGender}
    
    If one has two different datasets and wants to compare the  difference of Betas fitted, consider
    \code{\link{Diff2AFD}()} function, which produces a FullDiallelAnalyze whose
    chains are the difference of two AFD objects.
    
}
\references{ Diallel Paper }
\author{ Alan Lenarcic, Will Valdar }
\note{ 
  "FullDiallelAnalyze"  is a class that will analyze a dataset
}
\seealso{ FullDiallelAnalyze, FullDiallelSimulate, DiallelOb }
\examples{
## Load in R packages
try(require(lattice, quietly=TRUE, warn.conflicts=FALSE), silent=TRUE);
try(require(coda, quietly=TRUE, warn.conflicts=FALSE), silent=TRUE);
try(require(R.methodsS3, quietly=TRUE, warn.conflicts=FALSE), silent=TRUE);
try(require(R.oo, quietly=TRUE, warn.conflicts=FALSE), silent=TRUE);
try(require(corpcor, quietly=TRUE, warn.conflicts=FALSE), silent=TRUE);
require(BayesDiallel, quietly = TRUE, warn.conflicts=FALSE);
require(R.oo, warn.conflicts=FALSE, quietly=TRUE);


###############################################################################
## First Example Piximus Diallel Mouse Data.
data(PiximusData);
##  Data is in "Piximus.Data"
##  Models are in "Examples.Piximus.Models"
##  tau.Prior is in "Examples.Piximus.tau.Prior.Info"
####################################
###### Run the Algorithm->
AFD = DiallelAnalyzer(data = Piximus.Data, father.strain="father.strain.name",
   mother.strain="mother.strain.name", phenotype="MouseWeight", is.female="is.female",
   sep="", FixedEffects = NULL,
   RandomEffects = NULL, 
   Models=Example.Piximus.Models, sigmasq.start = 1,  numChains = 5,  lengthChains=2500,
   burnin = 1,
   DIC.Only=FALSE,  tauPriorFile = Example.Piximus.tau.Prior.Info, Verbose = 0,
   SaveAFDFile = "SaveAFDBackUpPiximusData.RData",
   LogTransform=TRUE);

if (FALSE) {
  library(R.oo);  library(BayesDiallel);
  load("SaveAFDBackUpPiximusData.RData");
}

AFD$ListElements;  ## List of Elements available to AFD
AFD$ListFunctions; ## List of Functions available to AFD  
   
## Get a summary of the Coda Chains for first Diallel Model
summary(AFD$AllDiallelObs[[1]]$CodaChains)
plot(AFD$AllDiallelObs[[1]]$CodaChains);
plot.hpd(AFD$AllDiallelObs[[1]]$CodaChains);

## Now make those TwoDiallelPlots!
## Plot Females, observed versus fitted
AFD$AllDiallelObs[[1]]$TwoDiallelPlot(FemalePlot = TRUE, MaleAgainstFemale = FALSE);

## PlotStrawPlot illustrates effects
AFD$AllDiallelObs[[1]]$PlotStrawPlot();

## Here "AFD" is the FullDiallel Analyze object
##   AFD$AllDiallelObs is a list of DiallelObs
##   AFD$AllDiallelObs[[1]] is the first Diallel Obs
AFD$AllDiallelObs[[1]]$ListElements  ## Elements of this DiallelObs

#################################################################################
##  HSq and RSq
##
##   HSq is our future heritability metric, based upon estimated tau^2 parameters,
##    it assumes independence of  future diallels.
##
##   RSq relates the amount of variation in Y explained by a covariate.  Note, that
##    because of correlation between terms, sum of RSq terms can be more or less than
##    total variation of Y.  
##
## Give a table summarizing beliefs in heritability ratios for future independent diallels.
##  expresses residual variance in terms of 
AFD$AllDiallelObs[[1]]$PosteriorHSqTable

## Inner method that calculates that HSq
OtherPosteriorChains = AFD$AllDiallelObs[[1]]$PosteriorHSq(UseFixed=TRUE, ProperRatio=TRUE,
      AFD = AFD, startiter = AFD$burin, thin = AFD$thin)
      
## Now look at RSq as a different metric
summary(AFD$AllDiallelObs[[1]]$PosteriorRSqChains);

##########################################################
## Set the model shape to simulate
  ModelVector = c(1,1,2,1,3,1);
  ajModel = ModelVector[1];
  MotherModel = ModelVector[2];
  CrossModel = ModelVector[3];
  BetaInbredLevel = ModelVector[4];
  SexModel = ModelVector[5];
  BetaInbredTimesSex = ModelVector[6];
  IsFixed = 1; IsRandom = 1;
  NumReps = 2 ## Imagine dataset of size 2 times full diallel
  numj = 8 ## 8 strains of mice?
  
  
print("Sampling NonDiallel Random and Fake Effects");
InFixedEffects=NULL; InRandomEffects =NULL;
if (IsFixed || IsRandom) {
   WantLen = (numj *(numj+1)/2 ) *NumReps ;
   InRandomEffects = sample(size=WantLen, 1:5, replace=TRUE);
   InFixedEffects = rnorm(WantLen);
   if (IsFixed == 0) {InFixedEffects=NULL;}
   if (IsRandom == 0) {InRandomEffects=NULL;}
   mRandomEffects = 20;
   dfRandomEffects = 5; tauFixedEffects = 20;
   NumRepetitions=1;
}  else {
   NumRepetitions = NumReps;
}

## Simulate a data set given model of choice
print("Making first Simulation");
### Allocate AFDS Diallel Simulation Object
AFDS <- FullDiallelSimulate(numj = numj, InFixedEffects = InFixedEffects,
 InRandomEffects = InRandomEffects, mRandomEffects = 20,
 dfRandomEffects = 5, tauFixedEffects = 20, YesSex = TRUE, NumRepetitions = NumRepetitions);

## Sample the parameters for Diallel Simulation Object
defaultSimulateParam(AFDS);
if (is.null(InRandomEffects) && is.null(InFixedEffects)) {
  SetupFilledSimulatedListjk(AFDS, NumRepetitions = NumRepetitions);
}

## Set up the model for Diallel Simulation Object
SetupSimulateMethod(AFDS, ajModel = 1, MotherModel = MotherModel, CrossModel =
  CrossModel, SexModel = SexModel, BetaInbredLevel = BetaInbredLevel, 
  BetaInbredTimesSex = BetaInbredTimesSex);
## SimValues now simulates a random Beta vector, tau vector, and observed data Y      
SimValues(AFDS, Sigma = 1);

#############################################################################
###  Begin Analysis
###
### From Simulated Diallel in AFDS, we pull observed data to put in an 
###  Analysis Diallel AFD

Y = AFDS$Y; ListjkInput = AFDS$Listjk;
SexInputVec = AFDS$SexVector

## Pull Out the RandomEffects
ARandomEffects = rep(0, length(AFDS$RandomEffects[,1]));
for (ii in 1:length(AFDS$RandomEffects[1,])) {
  ARandomEffects[AFDS$RandomEffects[,ii] == 1] = ii;
}
if (is.null(InRandomEffects)) { ARandomEfects = NULL; }
##TargetLength=TARGET;
SampleBeta = AFDS$ADiallelOb$Beta;
FileDir = AllDir2;
quantile = .95;
INTIN = 0;

## These are the true simulation parameters from AFDS we would like experiment to learn  
TrueParametersList = c(AFDS$ADiallelOb$Beta, AFDS$ADiallelOb$tau,
    AFDS$ADiallelOb$Sigma)

#######################################################3
## Setup Analysis
##
## Allocate AFD : FullDiallelAnalyze Object
AFD  <- FullDiallelAnalyze(Y = Y, 
      SexVector = SexInputVec,
      Listjk = ListjkInput, dfStart = .5, mStart = .5,
      InFixedEffects = AFDS$FixedEffects,
      InRandomEffects = ARandomEffects);

## Assemble a List of models to be considered by AFD
##  This is a k * 6 matrix;
##
## In our case, let k = 1, and supply AFD the "true" simulation model 
ExampleModelsList = matrix(c(ajModel, MotherModel, CrossModel,
      SexModel, BetaInbredLevel, BetaInbredTimesSex), 1, 6);
      Sigma = 1;  
      names(Sigma) = "SigmaAll";


##  Options for Chains:
##   Set "Wanted" in Analysis methods so that only certain variables in model are taken
##   Set "Extractor" in Analysis methods so that functions of variables in model are taken.
##   Use "AFD$On$State" to learn about variables in the State Vector for
##    Current DiallelModel
##   (Note, that is "AFD$AllDiallelObs[[AFD$OnObs]]$getState()")
OptWanted = NULL; OptExtractor = NULL;
##OptWanted = c("Mu", "aj:3", "Sigma:1")
## Setup Analysis Methods for AFD, including allocating for MCMC chains
## "Sigma" is starting Sigma anticipated noise value'
if (FALSE) {
 OptExtractor = function(State) {
   returnVec = c(State[["Mu"]], State[["Sigma:1"]],
     mean(State[substr(names(State),1,nchar("aj")) == "aj"])
   );
   names(returnVec) = c("Mu", "Sigma:1", "Meanaj");
   return(returnVec);
 }
}
SetupAnalysisMethods(AFD, ExampleModelsList, Sigma = Sigma,
      numChains = 3, lengthChains = 2000,Wanted = OptWanted,
      Extractor = OptExtractor);

#######################################################
## This will run the MCMC sampler on Model of choice
t1 = proc.time();
  RunChains(AFD);
t2 = proc.time();                  
print(t2-t1); ## Print Run time

ADO = AFD$AllDiallelObs[[1]];  ## This is the DiallelOb corresponding to our model

plot(ADO$CodaChains);  ## Plot the chains to understand
summary(ADO$CodaChains);  ## Get Summary information on a parameters
                                          
plot.hpd(ADO$CodaChains); ## Using Library_diallel_helper, plot chains.

plot.corr(crosscorr(ADO$CodaChains)) ## Look at cross correlations of coda chains


CalcDICC(ADO, AFD) ## DIC value for this Coda Chain  

## This creates a summary table of applicable elements
MySum = summary.table(ADO, burnin = 400, AFD=AFD);

#MyPostSumGivesValues for all the diallel squares of every gender
MyPostSum = PosteriorPredSummary(ADO, AFD, burnin = 400, AFD=AFD, keep = TRUE);

SimmedGrid = GiveGrid(AFDS);
par(mfrow=c(1,2));
draw.diallel(data =SimmedGrid[MyPostSum$"Female/Male" == 1,], phenotype = "Mean.Simulated")
draw.diallel(data = MyPostSum[MyPostSum$"Female/Male" == 1,], phenotype = "Mean Posterior")
  
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ methods }
\keyword{ ts }% __ONLY ONE__ keyword per line
