\name{ReadModels}
\alias{ReadModels}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Convert text list to models matrix }
\description{
  Wrapper function used by \code{\link{DiallelAnalyzer}} to a matrix containing model flags of type
  \code{\link{BayesDiallelHiddenDetails}}    for use in \code{\link{SetupanalysisMethods}}().
  
  See \code{\link{ModelsFile}} for examples of input Modelsfile text string formats
}
\usage{
ReadModels(filename = NULL, StringInput = "", MyLines = "Fulls");
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{filename}{Name for a a readin text file where each line denotes a new model for the diallel to analyze}
  \item{StringInput}{A string to be input}
  \item{MyLines}{A vector of strings to input}

}
\details{
  ReadModels uses several grep/perl matching methods to convert text strings to a models matrix.
}
\value{
   Returns a models matrix with flags for various effects set up.  
}
\references{ Diallel Paper }
\author{ Alan Lenarcic, Will Valdar }
\note{ 
  "\code{\link{DiallelAnalyzer}}()"  uses this method by default.
}
\seealso{ \code{\link{ModelsFile}}, \code{\link{FullDiallelAnalyze}}, 
  \code{\link{FullDiallelSimulate}}, \code{\link{DiallelOb}}, \code{\link{DiallelAnalyzer}} }
\examples{
## Load in R packages
try(require(lattice, quietly=TRUE, warn.conflicts=FALSE), silent=TRUE);
try(require(coda, quietly=TRUE, warn.conflicts=FALSE), silent=TRUE);
try(require(R.methodsS3, quietly=TRUE, warn.conflicts=FALSE), silent=TRUE);
try(require(R.oo, quietly=TRUE, warn.conflicts=FALSE), silent=TRUE);
try(require(corpcor, quietly=TRUE, warn.conflicts=FALSE), silent=TRUE);
require(BayesDiallel, quietly = TRUE, warn.conflicts=FALSE);
require(R.oo, warn.conflicts=FALSE, quietly=TRUE);


###############################################################################
## First Example Piximus Diallel Mouse Data.
data(PiximusData);

print(Example.Piximus.Models);
ReadModels(MyLines = Example.Piximus.Models);

ReadModels(MyLines="Fulls");
ReadModels(MyLines="Fullu");
ReadModels(MyLines=c("Bs, as, vs, w",
             "bsasvw", "am", "av_sw") );
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ methods }
\keyword{ ts }% __ONLY ONE__ keyword per line
